DECLARE SUB loadtables ()
DECLARE SUB loadboard ()
DECLARE SUB grouvline (xscr&, d1&, d2&, sectnum%)
CONST XDIM = 320, YDIM = 200, PIXS = 1
COMMON SHARED posx&, posy&, posz&, ang%
DIM SHARED sintable&(2048), umost%(320), dmost%(320)
DIM SHARED a%(64, 64), b%(64, 64)

SCREEN 13: DEF SEG = &HA000
CALL loadtables
CALL loadboard

DO
  FOR x& = 0 TO XDIM - 1 STEP PIXS
     umost%(x&) = 0: dmost%(x&) = 200
     IF x& < 160 THEN
        CALL grouvline(x&, 0, 20480, 0)
     ELSE
        CALL grouvline(x&, 8192, 16384, 0)
     END IF
     'LINE (x&, 0)-(x&, dmost%(x&)), 0
  NEXT x&
  DO
     Z$ = INKEY$
     IF Z$ = "A" OR Z$ = "a" THEN posz& = posz& + 2
     IF Z$ = "Z" OR Z$ = "z" THEN posz& = posz& - 2
     IF Z$ = CHR$(0) + CHR$(75) THEN ang% = (ang% + 2016) AND 2047
     IF Z$ = CHR$(0) + CHR$(77) THEN ang% = (ang% + 32) AND 2047
     IF Z$ = CHR$(0) + CHR$(72) THEN
        posx& = posx& + sintable&((ang% + 2560) AND 2047) \ 16
        posy& = posy& + sintable&((ang% + 2048) AND 2047) \ 16
     END IF
     IF Z$ = CHR$(0) + CHR$(80) THEN
        posx& = posx& - sintable&((ang% + 2560) AND 2047) \ 16
        posy& = posy& - sintable&((ang% + 2048) AND 2047) \ 16
     END IF
  LOOP WHILE Z$ <> "" AND Z$ <> CHR$(27)
LOOP WHILE Z$ <> CHR$(27)
END

SUB grouvline (xscr&, d1&, d2&, sectnum%)
   IF d2& <= d1& OR umost%(xscr&) >= dmost%(xscr&) THEN EXIT SUB
  
   DIM grid%(2), dist&(2), dinc&(2), dir%(2), incr&(2)
  
   p& = dmost%(xscr&) * 320& + xscr&: DEF SEG = &HA000
  
   cosval& = sintable&((ang% + 2560) AND 2047)
   sinval& = sintable&((ang% + 2048) AND 2047)
   tempx& = d1&: tempy& = (d1& * (xscr& - 160)) \ 160
   x1& = posx& + (tempx& * cosval& - tempy& * sinval&) \ 16384
   y1& = posy& + (tempy& * cosval& + tempx& * sinval&) \ 16384
   tempx& = d2&: tempy& = (d2& * (xscr& - 160)) \ 160
   x2& = posx& + (tempx& * cosval& - tempy& * sinval&) \ 16384
   y2& = posy& + (tempy& * cosval& + tempx& * sinval&) \ 16384
   LINE (160 + x1& \ 256, 100 + y1& \ 256)-(160 + x2& \ 256, 100 + y2& \ 256), 4

   incr&(0) = (tempx& * cosval& - tempy& * sinval&) \ 256
   incr&(1) = (tempy& * cosval& + tempx& * sinval&) \ 256
   dir%(0) = SGN(incr&(0)): incr&(0) = ABS(incr&(0))
   dir%(1) = SGN(incr&(1)): incr&(1) = ABS(incr&(1))
   stx& = posx& AND &HFFFFFC00: IF dir%(0) = 1 THEN stx& = stx& + 1024
   sty& = posy& AND &HFFFFFC00: IF dir%(1) = 1 THEN sty& = sty& + 1024
   cnt& = (ABS(stx& - posx&) * incr&(1) - ABS(sty& - posy&) * incr&(0)) \ 1024&
   grid%(0) = (posx& \ 1024) AND 63: grid%(1) = (posy& \ 1024) AND 63
      
   IF incr&(0) <> 0 THEN
      dinc&(0) = ((65536 * 1024&) \ ABS(x2& - posx&)) * (d2& \ 1024)
      dist&(0) = (dinc&(0) \ 1024&) * ABS(stx& - posx&)
   END IF
   IF incr&(1) <> 0 THEN
      dinc&(1) = ((65536 * 1024&) \ ABS(y2& - posy&)) * (d2& \ 1024)
      dist&(1) = (dinc&(1) \ 1024&) * ABS(sty& - posy&)
   END IF
   IF dist&(0) <= 0 THEN dist&(0) = 1
   IF dist&(1) <= 0 THEN dist&(1) = 1
  
   dstart& = d1& * 64
   dend& = d2& * 64
   dm% = dmost%(xscr&)
   SWAP incr&(0), incr&(1): incr&(1) = -incr&(1)
  
   DO
      index% = ABS(cnt& >= 0): cnt& = cnt& + incr&(index%)
      grid%(index%) = (grid%(index%) + dir%(index%)) AND 63
      odist& = dist&(index%)
      dist&(index%) = dist&(index%) + dinc&(index%)
   LOOP WHILE odist& < dstart&

   'stx& = x1&
   'sty& = y1&
   'cnt& = 0
   'grid%(0) = ((stx& \ 1024) AND 63): IF dir%(0) < 0 THEN grid%(0) = grid%(0) - 1
   'grid%(1) = ((sty& \ 1024) AND 63): IF dir%(1) < 0 THEN grid%(1) = grid%(1) - 1
   'dist& = (((stx& - posx&) \ 16) * (cosang& \ 256) - ((sty& - posy&) \ 16) * (sinang& \ 256))
   'dist&(0) = dist&
   'dist&(1) = dist&
   'IF dist&(0) <= 0 THEN dist&(0) = 1
   'IF dist&(1) <= 0 THEN dist&(1) = 1
  
   DO
      col% = b%(grid%(0), grid%(1))
     
      index% = ABS(cnt& >= 0): cnt& = cnt& + incr&(index%)
     
      y& = a%(grid%(0), grid%(1))
      y& = ((y& + posz&) * 2097152) \ dist&(index%) + (YDIM \ 2)
     
      grid%(index%) = (grid%(index%) + dir%(index%)) AND 63
      odist& = dist&(index%)
      dist&(index%) = dist&(index%) + dinc&(index%)
     
      PSET (160 + ((dist&(0) \ 16) * (x2& \ 16)) \ 1048576, 100 + ((dist&(1) \ 16) * (y2& \ 16)) \ 1048576), 8
      IF y& <= dm% THEN
         IF y& < umost%(xscr&) THEN EXIT DO
         WHILE dm% >= y&
            p& = p& - 320&: POKE p&, col%
            dm% = dm% - 1
         WEND
      END IF
   LOOP WHILE odist& < dend&
   dmost%(xscr&) = dm%
   IF y& < umost%(xscr&) THEN
      y& = umost%(xscr&)
      FOR zx% = y& TO dmost%(xscr&)
         p& = p& - 320&: POKE p&, col%
      NEXT zx%
   END IF

END SUB

SUB loadboard
   posx& = 0
   posy& = 0
   posz& = -48
   ang% = 1536

   FOR Z% = 0 TO 63
      FOR zz% = 0 TO 63
         a%(Z%, zz%) = 64
         b%(Z%, zz%) = Z% * 4 + zz% * 6 + 32
      NEXT zz%
   NEXT Z%
END SUB

SUB loadtables
   FOR Z& = 0 TO 511
      sintable&(Z&) = 16384& * SIN(Z& * 3.141592 / 1024)
   NEXT Z&
   FOR Z& = 512 TO 1023
      sintable&(Z&) = sintable&(1023 - Z&)
   NEXT Z&
   FOR Z& = 1024 TO 2047
      sintable&(Z&) = -sintable&(Z& - 1024)
   NEXT Z&

END SUB

