SCREEN 0: CLS : FILES "*.pal"
LOCATE 20, 1: PRINT "Palette filename? (Default = Palette.pal)"
LOCATE 21, 1: INPUT palfil$
IF palfil$ = "" THEN palfil$ = "Palette.pal"
SCREEN 0: CLS : FILES "*.lmp"
LOCATE 20, 1: PRINT "Palette lookup filename? (Default = Colormap.lmp)"
LOCATE 21, 1: INPUT palookupfil$
IF palookupfil$ = "" THEN palookupfil$ = "Colormap.lmp"

SCREEN 13
OPEN palfil$ FOR BINARY AS #1
pal$ = STRING$(768, 0): GET #1, , pal$
div% = 1
FOR z% = 0 TO 767
   IF ASC(MID$(pal$, z% + 1, 1)) > 63 THEN div% = 4
NEXT z%
OUT &H3C8, 0
FOR z% = 0 TO 767
   OUT &H3C9, ASC(MID$(pal$, z% + 1, 1)) \ div%
NEXT z%
CLOSE #1

OPEN palookupfil$ FOR BINARY AS #1
FOR shade% = 0 TO 127
   pal$ = STRING$(256, 0): GET #1, , pal$
   FOR z% = 0 TO 255
      PSET (z%, shade%), ASC(MID$(pal$, z% + 1, 1))
   NEXT z%
NEXT shade%
CLOSE #1

LOCATE 18, 1: PRINT "Save to palette.dat?";
DO
   z$ = UCASE$(INPUT$(1))
LOOP WHILE z$ <> "Y" AND z$ <> "N"
IF z$ = "Y" THEN
   LOCATE 18, 1: PRINT "Start on what row (Default = 64)";
   LOCATE 19, 1: INPUT starty$: starty% = VAL(starty$)
   IF starty$ = "" THEN starty% = 64: LOCATE 19, 1: PRINT starty%
   LOCATE 20, 1: PRINT "End on what row (Default = 127)";
   LOCATE 21, 1: INPUT endy$: endy% = VAL(endy$)
   IF endy$ = "" THEN endy% = 127: LOCATE 21, 1: PRINT endy%
   LOCATE 22, 1: PRINT "Step (Default = 2)";
   LOCATE 23, 1: INPUT dastep$: dastep% = VAL(dastep$)
   IF dastep$ = "" THEN dastep% = 2: LOCATE 23, 1: PRINT dastep%

   SHELL "del palette.dat"
  
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   OUT &H3C7, 0
   FOR z% = 0 TO 767
      MID$(pal$, z% + 1, 1) = CHR$(INP(&H3C9))
   NEXT z%
   PUT #1, , pal$
   FOR y% = starty% TO endy% STEP dastep%
      pal$ = STRING$(256, 0)
      FOR x% = 0 TO 255
         MID$(pal$, x% + 1, 1) = CHR$(POINT(x%, y%))
      NEXT x%
      PUT #1, , pal$
   NEXT y%

   PRINT "Palette.dat Saved!"
   CLOSE #1
ELSE
   PRINT "Aborted!"
END IF

