SCREEN 12

CONST XDIM = 640
DIM radarang%(320), radarang2%(XDIM)
DIM sintable%(2048), tantable&(2048)
    
OPEN "tables.dat" FOR BINARY AS #1
FOR z% = 0 TO 2047: GET #1, , sintable%(z%): NEXT z%
FOR z% = 0 TO 1023: GET #1, , tantable&(z%): NEXT z%
FOR z% = 0 TO 319: GET #1, , radarang%(z%): NEXT z%

CLOSE #1

FOR scrx% = XDIM - 1 TO 0 STEP -1
   x& = (scrx% * 320& * 4096&) \ XDIM
   frac& = x& AND 4095: x& = (x& - frac%) \ 4096
   IF x& >= 319 THEN
      radarang2%(scrx%) = radarang%(319) \ 64
   ELSE
      radarang2%(scrx%) = (radarang%(x&) + ((radarang%(x& + 1) - radarang%(x&)) * frac&) \ 4096) \ 64
   END IF
NEXT scrx%

LINE (0, 240)-(639, 240), 8
LINE (320, 0)-(320, 480), 8
FOR z% = 0 TO XDIM - 1
   PSET (z% * 640& \ XDIM, ((radarang2%(z%) + 128) AND 255) - 128 + 240), 15
NEXT z%

