DECLARE FUNCTION getangle% (dx&, dy&)
DECLARE SUB scan (x1&, y1&, x2&, y2&)
COMMON SHARED posx&, posy&
DIM SHARED sintable&(2048)
FOR z% = 0 TO 2047
   sintable&(z%) = 16384 * SIN(z% * 3.14159265358979# / 1024)
NEXT z%
pag& = 0: SCREEN 9, , pag&, 1 - pag&
RANDOMIZE TIMER
DO
   DO
      posx& = INT(480 * RND) + 80: posy& = INT(300 * RND) + 25
      x1& = INT(480 * RND) + 80: y1& = INT(300 * RND) + 25
      x2& = INT(480 * RND) + 80: y2& = INT(300 * RND) + 25
   LOOP WHILE ((getangle%(x2& - posx&, y2& - posy&) - getangle%(x1& - posx&, y1& - posy&) + 2048) AND 2047) > 512
   posx& = posx& * 64: posy& = posy& * 64
   x1& = x1& * 64: y1& = y1& * 64
   x2& = x2& * 64: y2& = y2& * 64
  
   LINE (0, 0)-(639, 349), 0, BF
   FOR z& = 0 TO 639 STEP 16
      LINE (z&, 0)-(z&, 479), 8
   NEXT z&
   FOR z& = 0 TO 349 STEP 16
      LINE (0, z&)-(639, z&), 8
   NEXT z&
  
   CALL scan(x1&, y1&, x2&, y2&)
   LINE (posx& \ 64, posy& \ 64)-(x1& \ 64, y1& \ 64), 15
   LINE (posx& \ 64, posy& \ 64)-(x2& \ 64, y2& \ 64), 14
   LINE (x1& \ 64, y1& \ 64)-(x2& \ 64, y2& \ 64), 1
   SCREEN 9, , pag&, 1 - pag&: pag& = 1 - pag&
   DO: LOOP WHILE INKEY$ = ""
LOOP WHILE INKEY$ = ""

FUNCTION getangle% (dx&, dy&)
   ang% = 1024: incr& = 512
   FOR z% = 0 TO 9
      IF dy& * sintable&((ang% + 512) AND 2047) > dx& * sintable&(ang% AND 2047) THEN
         ang% = ang% + incr&
      ELSE
         ang% = ang% - incr&
      END IF
      incr& = incr& \ 2
   NEXT z%
   d1& = dy& * sintable&((ang% + 2559) AND 1023) - dx& * sintable&((ang% + 2047) AND 1023)
   d2& = dy& * sintable&((ang% + 2560) AND 1023) - dx& * sintable&((ang% + 2048) AND 1023)
   d3& = dy& * sintable&((ang% + 2561) AND 1023) - dx& * sintable&((ang% + 2049) AND 1023)
   IF d1& < d2& THEN ang% = ang% - 1
   IF d3& < d2& THEN ang% = ang% + 1
   getangle% = ang%
END FUNCTION

SUB scan (x1&, y1&, x2&, y2&)
   px& = posx& \ 1024: py& = posy& \ 1024

   incrx1& = (x1& - posx&): incry1& = (y1& - posy&)
   xdir1& = SGN(incrx1&): incrx1& = ABS(incrx1&)
   ydir1& = SGN(incry1&): incry1& = ABS(incry1&)
   gridx1& = posx& \ 1024: gridy1& = posy& \ 1024
   snx& = posx& AND 1023: IF xdir1& = 1 THEN snx& = snx& XOR 1023
   sny& = posy& AND 1023: IF ydir1& = 1 THEN sny& = sny& XOR 1023
   cnt1& = (snx& * incry1& - sny& * incrx1&) \ 1024
  
   incrx2& = (x2& - posx&): incry2& = (y2& - posy&)
   xdir2& = SGN(incrx2&): incrx2& = ABS(incrx2&)
   ydir2& = SGN(incry2&): incry2& = ABS(incry2&)
   gridx2& = posx& \ 1024: gridy2& = posy& \ 1024
   snx& = posx& AND 1023: IF xdir2& = 1 THEN snx& = snx& XOR 1023
   sny& = posy& AND 1023: IF ydir2& = 1 THEN sny& = sny& XOR 1023
   cnt2& = (snx& * incry2& - sny& * incrx2&) \ 1024
  
   scanstop1& = ABS((posx& \ 1024) - (x1& \ 1024)) + ABS((posy& \ 1024) - (y1& \ 1024))
   scanstop2& = ABS((posx& \ 1024) - (x2& \ 1024)) + ABS((posy& \ 1024) - (y2& \ 1024))
   IF scanstop1& > scanstop2& THEN scanstop& = scanstop1& ELSE scanstop& = scanstop2&
  
   snx& = 0: IF y2& < y1& THEN snx& = 1023
   sny& = 0: IF x2& > x1& THEN sny& = 1023
  
   FOR scandist& = 0 TO scanstop&
     
      x& = gridx1&: y& = gridy1&
      side3& = (x& * 1024& + snx& - x1&) * (y2& - y1&) - (x2& - x1&) * (y& * 1024& + sny& - y1&)
      ox& = -1
      WHILE ox& <> gridx2& OR oy& <> gridy2&
         IF side3& < 0 THEN LINE (x& * 16 + 1, y& * 16 + 1)-(x& * 16 + 15, y& * 16 + 15), 4, B
         ox& = x&: oy& = y&
         IF ox& >= px& AND oy& < py& + scandist& THEN y& = y& + 1: side3& = side3& - (x2& - x1&) * 1024&
         IF ox& <= px& AND oy& > py& - scandist& THEN y& = y& - 1: side3& = side3& + (x2& - x1&) * 1024&
         IF oy& >= py& AND ox& > px& - scandist& THEN x& = x& - 1: side3& = side3& - (y2& - y1&) * 1024&
         IF oy& <= py& AND ox& < px& + scandist& THEN x& = x& + 1: side3& = side3& + (y2& - y1&) * 1024&
      WEND
     
      IF cnt1& < 0 THEN
         cnt1& = cnt1& + incry1&: gridx1& = gridx1& + xdir1&
      ELSE
         cnt1& = cnt1& - incrx1&: gridy1& = gridy1& + ydir1&
      END IF
    
      IF cnt2& < 0 THEN
         cnt2& = cnt2& + incry2&: gridx2& = gridx2& + xdir2&
      ELSE
         cnt2& = cnt2& - incrx2&: gridy2& = gridy2& + ydir2&
      END IF

   NEXT scandist&
END SUB

