DECLARE SUB fastcopy (x1&, y1&, x2&, y2&, xsiz&, ysiz&)
DECLARE SUB hlin (start&, leng%, col%)
DECLARE SUB vlin (start&, startpag%, leng%, col%)
DECLARE SUB vline2 (x&, ydim&, segtemp&, offtemp&, stp%, shadeoffs%)
COMMON SHARED xres&

xres& = 1024
maxdim% = 128
maxwalls% = 4096
boardsiz& = 64

OPTION BASE 0
DIM regs%(7)
regs%(0) = &H38: CALL int86old(&H10, regs%(), regs%())
regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
DIM pal%(768), cl%(16, 3), palookup%(256), band%(16), cache%(16, 12)
DIM buf%(maxdim%, maxdim%), buf2%(maxdim%, maxdim%)
DIM board%(boardsiz&, boardsiz&)
DIM walsiz%(maxwalls%), walanm%(maxwalls%), walsiz2%(maxwalls%)
picsbuf$ = STRING$(4096, 0)
DIM pow2&(16)
pow2&(0) = 1: pow2&(1) = 2: pow2&(2) = 4: pow2&(3) = 8
pow2&(4) = 16: pow2&(5) = 32: pow2&(6) = 64: pow2&(7) = 128
pow2&(8) = 256: pow2&(9) = 512: pow2&(10) = 1024: pow2&(11) = 2048
pow2&(12) = 4096: pow2&(13) = 8192: pow2&(14) = 16384: pow2&(15) = 32768
wallnum& = 0: anywallstatchg% = 0: updat$ = ""

OPEN "pics.dat" FOR BINARY AS #1
OPEN "2board.dat" FOR BINARY AS #2
z$ = STRING$(8192, 0): GET #2, , z$
FOR z% = 0 TO boardsiz& - 1
   FOR zz% = 0 TO boardsiz& - 1
      board%(z%, zz%) = CVI(MID$(z$, (z% * boardsiz& + zz%) * 2 + 1, 2))
   NEXT zz%
NEXT z%
GOSUB loadpicheader
GOSUB setupcolors
trailstatus% = 0
lastloaded% = -1
FOR z% = 0 TO 15
   FOR zz% = 0 TO 11
      cache%(z%, zz%) = -1
   NEXT zz%
NEXT z%
x% = boardsiz& \ 2: y% = boardsiz& \ 2: xx% = x% - (512 \ boardsiz&): yy% = y% - (384 \ boardsiz&)
justarted% = 0: GOSUB drawboard
picnum% = 0: trail% = 0
DO
   DO
      z$ = UCASE$(INKEY$)
   LOOP WHILE z$ = ""
   ox% = x%: oy% = y%
   IF z$ = CHR$(0) + CHR$(75) AND x% > 0 THEN x% = x% - 1: GOSUB drawboard
   IF z$ = CHR$(0) + CHR$(77) AND x% < boardsiz& - 1 THEN x% = x% + 1: GOSUB drawboard
   IF z$ = CHR$(0) + CHR$(72) AND y% > 0 THEN y% = y% - 1: GOSUB drawboard
   IF z$ = CHR$(0) + CHR$(80) AND y% < boardsiz& - 1 THEN y% = y% + 1: GOSUB drawboard
   IF z$ = CHR$(9) THEN picnum% = board%(x%, y%)
   IF z$ = "T" THEN trail% = trail% XOR 1
   IF z$ = " " OR trail% = 1 THEN board%(x%, y%) = picnum%: GOSUB drawboard
   IF z$ = "+" OR z$ = "-" THEN
      obord% = board%(x%, y%)
      IF z$ = "-" AND board%(x%, y%) > 0 THEN board%(x%, y%) = board%(x%, y%) - 1
      IF z$ = "+" AND board%(x%, y%) < maxwalls% THEN board%(x%, y%) = board%(x%, y%) + 1
      IF obord% <> board%(x%, y%) THEN GOSUB drawboard
      picnum% = board%(x%, y%)
   END IF
   IF z$ = "F" THEN board%(x%, y%) = board%(x%, y%) XOR 8192
   IF z$ = "C" THEN
      oldpicnum% = board%(x%, y%)
      FOR z% = 0 TO boardsiz& - 1
         FOR zz% = 0 TO boardsiz& - 1
            IF board%(z%, zz%) = oldpicnum% THEN board%(z%, zz%) = picnum%
         NEXT zz%
      NEXT z%
      justarted% = 0: GOSUB drawboard
   END IF
LOOP WHILE z$ <> CHR$(27)
regs%(0) = &H3: CALL int86old(&H10, regs%(), regs%())
z$ = ""
FOR z% = 0 TO boardsiz& - 1
   FOR zz% = 0 TO boardsiz& - 1
      z$ = z$ + MKI$(board%(z%, zz%))
   NEXT zz%
NEXT z%
SEEK #2, 1
PUT #2, , z$
CLOSE #1
CLOSE #2
END

setupcolors:
   OPEN "palette.dat" FOR BINARY AS #3
   pal$ = STRING$(768, 0)
   GET #3, , pal$
   OUT &H3C8, 0
   FOR z% = 0 TO 767
      pal%(z%) = ASC(MID$(pal$, z% + 1, 1))
      OUT &H3C9, pal%(z%)
   NEXT z%
   CLOSE #3
RETURN
  
loadpicheader:
   SEEK #1, 1
   buf$ = STRING$(maxwalls%, 0)
   GET #1, , buf$
   FOR z% = 0 TO maxwalls% - 1
      walsiz%(z%) = ASC(MID$(buf$, z% + 1, 1))
   NEXT z%
   buf$ = STRING$(maxwalls%, 0)
   GET #1, , buf$
   FOR z% = 0 TO maxwalls% - 1
      walanm%(z%) = ASC(MID$(buf$, z% + 1, 1))
   NEXT z%
RETURN

loadnewall2:
   IF walsiz%(wallnumber&) = 0 THEN RETURN
   FOR z% = 0 TO wallnumber& - 1
      IF walsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((walsiz%(z%) AND 15) + (walsiz%(z%) \ 16))
   NEXT z%
   SEEK #1, totsiz& + maxwalls% * 2 + 1
   xdim& = 2 ^ (walsiz%(wallnumber&) AND 15)
   ydim& = 2 ^ (walsiz%(wallnumber&) \ 16)
   buf$ = STRING$(xdim& * ydim&, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO xdim& - 1
      FOR zz% = 0 TO ydim& - 1
         buf2%(z%, zz%) = PEEK(offs&): offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
RETURN

drawboard:
   oxx% = xx%: oyy% = yy%
   IF x% < xx% THEN xx% = xx% - 4: IF xx% < 0 THEN xx% = 0
   IF x% > xx% + (1024 \ boardsiz&) - 1 THEN xx% = xx% + 4: IF xx% > boardsiz& - (1024 \ boardsiz&) THEN xx% = boardsiz& - (1024 \ boardsiz&)
   IF y% < yy% THEN yy% = yy% - 3: IF yy% < 0 THEN yy% = 0
   IF y% > yy% + (768 \ boardsiz&) - 1 THEN yy% = yy% + 3: IF yy% > boardsiz& - (768 \ boardsiz&) THEN yy% = boardsiz& - (768 \ boardsiz&)
   IF justarted% = 0 OR xx% <> oxx% OR yy% <> oyy% THEN
      justarted% = 1
      FOR z% = xx% TO xx% + (1024 \ boardsiz&) - 1
         FOR zz% = yy% TO yy% + (768 \ boardsiz&) - 1
            xplc& = (z% - xx%) * boardsiz&
            yplc& = (zz% - yy%) * boardsiz&
            walnume& = board%(z%, zz%)
            GOSUB showall
         NEXT zz%
      NEXT z%
   ELSE
      xplc& = (ox% - xx%) * boardsiz&
      yplc& = (oy% - yy%) * boardsiz&
      walnume& = board%(ox%, oy%)
      GOSUB showall
   END IF
   OUT &H3CD, y% - yy%: CALL hlin((x% - xx%) * 64, 64, 31)
   OUT &H3CD, y% - yy%: CALL hlin((x% - xx%) * 64 + 64512, 64, 31)
   CALL vlin((x% - xx%) * 64, y% - yy%, 63, 31)
   CALL vlin((x% - xx%) * 64 + 63, y% - yy%, 63, 31)
   cache%(x% - xx%, y% - yy%) = -1
RETURN

showall:
   IF walsiz%(walnume& AND (maxwalls% - 1)) = 0 THEN RETURN
   FOR zx& = 0 TO 15
      FOR zzx& = 0 TO 11
         IF cache%(zx&, zzx&) = walnume& THEN
            CALL fastcopy(zx& * boardsiz&, zzx& * boardsiz&, xplc&, yplc&, 64&, 64&)
            cache%(xplc& \ boardsiz&, yplc& \ boardsiz&) = walnume&
            RETURN
         END IF
      NEXT zzx&
   NEXT zx&
   cache%(xplc& \ boardsiz&, yplc& \ boardsiz&) = walnume&
   IF lastloaded% <> walnume& THEN
      totsiz& = 0
      FOR zx% = 0 TO (walnume& AND (maxwalls% - 1)) - 1
         IF walsiz%(zx%) > 0 THEN totsiz& = totsiz& + pow2&(((walsiz%(zx%) AND 15) + (walsiz%(zx%) \ 16)))
      NEXT zx%
      SEEK #1, totsiz& + maxwalls% * 2 + 1
      xdim& = pow2&((walsiz%(walnume& AND (maxwalls% - 1)) AND 15))
      ydim& = pow2&((walsiz%(walnume& AND (maxwalls% - 1)) \ 16))
      GET #1, , picsbuf$
      lastloaded% = walnume&
   END IF

   startp& = (yplc& AND 63) * xres& + xplc&
   OUT &H3CD, yplc& \ 64
   xdim& = pow2&(walsiz%(walnume& AND (maxwalls% - 1)) AND 15)
   ydim& = pow2&(walsiz%(walnume& AND (maxwalls% - 1)) \ 16)
   IF xdim& <= 64 AND ydim& <= 64 THEN
      stp% = 1: stpadd& = ydim& * 2&
   ELSE
      stp% = 2: stpadd& = ydim& * 4&: xdim& = xdim& \ 2
   END IF
   tempseg& = VARSEG(picsbuf$)
   offs& = SADD(picsbuf$)
   FOR zx& = startp& TO startp& + xdim& - 1 STEP 2
      CALL vline2(zx&, ydim&, tempseg&, offs&, stp%, shadeoffs%)
      offs& = offs& + stpadd&
   NEXT zx&
RETURN

SUB fastcopy (x1&, y1&, x2&, y2&, xsiz&, ysiz&)
   OUT &H3CE, &H5: OUT &H3CF, (INP(&H3CF) AND &HFC) + 1   'WRITE MODE 1
   OUT &H3C4, 2: OUT &H3C5, 15

   OUT &H3C4, &H4: OUT &H3C5, INP(&H3C5) AND (255 - 8)    'CHAIN 4 OFF
   OUT &H3D4, &H17: OUT &H3D5, INP(&H3D5) OR 64           'WORD MODE
   OUT &H3D4, &H14: OUT &H3D5, INP(&H3D5) AND (255 - 64)  '2-WORD MODE

   OUT &H3CD, (y1& \ 256) * 16 + (y2& \ 256)
   siplc& = ((y1& AND 255) * 256&) + (x1& \ 4&)
   diplc& = ((y2& AND 255) * 256&) + (x2& \ 4&)
   DIM asmprog%(22)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55
   POKE p& + 1, &H8B: POKE p& + 2, &HEC
   POKE p& + 3, &HB8: POKE p& + 4, &H0: POKE p& + 5, &HA0
   POKE p& + 6, &H1E
   POKE p& + 7, &H8E: POKE p& + 8, &HD8
   POKE p& + 9, &H8E: POKE p& + 10, &HC0
   POKE p& + 11, &HBE: POKE p& + 12, siplc& AND 255: POKE p& + 13, siplc& \ 256
   POKE p& + 14, &HBF: POKE p& + 15, diplc& AND 255: POKE p& + 16, diplc& \ 256
   POKE p& + 17, &HB8: POKE p& + 18, (ysiz& - 1) AND 255: POKE p& + 19, (ysiz& - 1) \ 256
   POKE p& + 20, &HB9: POKE p& + 21, (xsiz& \ 4) AND 255: POKE p& + 22, (xsiz& \ 4) \ 256
   POKE p& + 23, &HF3: POKE p& + 24, &HA4
   POKE p& + 25, &H81: POKE p& + 26, &HC6: POKE p& + 27, (256 - (xsiz& \ 4)) AND 255: POKE p& + 28, (256 - (xsiz& \ 4)) \ 256
   POKE p& + 29, &H81: POKE p& + 30, &HC7: POKE p& + 31, (256 - (xsiz& \ 4)) AND 255: POKE p& + 32, (256 - (xsiz& \ 4)) \ 256
   POKE p& + 33, &H2D: POKE p& + 34, &H1: POKE p& + 35, &H0
   POKE p& + 36, &H73: POKE p& + 37, &HEE
   POKE p& + 38, &H1F
   POKE p& + 39, &H5D
   POKE p& + 40, &HCA: POKE p& + 41, &H2: POKE p& + 42, &H0
  
   CALL ABSOLUTE(0, p&)
   OUT &H3CE, &H5: OUT &H3CF, INP(&H3CF) AND &HFC       'WRITE MODE 0
   OUT &H3C4, 4: OUT &H3C5, INP(&H3C5) OR 8             'CHAIN 4 ON

'55           push bp
'8b ec        mov bp, sp
'b8 00 A0     mov ax, &Ha000
'1e           push ds
'8e d8        mov ds, ax
'8e c0        mov es, ax
'be ?  ?      mov si, source
'bf ?  ?      mov di, dest
'b8 ?  ?      mov ax, ysiz
'b9 ?  ?  lab:mov cx, (xsiz/4)
'f3 a4        rep movsb
'81 c6 ?  ?   add si, 1024-(xlen/4)
'81 c7 ?  ?   add di, 1024-(xlen/4)
'2d 01 00     sub ax, 1
'73 ee        jae lab
'1f           pop ds
'5d           pop bp
'ca 02 00     ret 2

END SUB

SUB hlin (start&, leng%, col%)
   DIM asmprog%(15)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55
   POKE p& + 1, &H8B
   POKE p& + 2, &HEC
   POKE p& + 3, &HB8
   POKE p& + 4, &H0
   POKE p& + 5, &HA0
   POKE p& + 6, &H8E
   POKE p& + 7, &HC0
   POKE p& + 8, &HB9
   POKE p& + 9, leng% AND 255
   POKE p& + 10, leng% \ 256
   POKE p& + 11, &HBF
   POKE p& + 12, start& AND 255
   POKE p& + 13, start& \ 256
   POKE p& + 14, &HB8
   POKE p& + 15, col%
   POKE p& + 16, col%
   POKE p& + 17, &HD1
   POKE p& + 18, &HE9
   POKE p& + 19, &HF3
   POKE p& + 20, &HAB
   POKE p& + 21, &HD1
   POKE p& + 22, &HD1
   POKE p& + 23, &H83
   POKE p& + 24, &HE1
   POKE p& + 25, &H1
   POKE p& + 26, &HF3
   POKE p& + 27, &HAA
   POKE p& + 28, &H5D
   POKE p& + 29, &HCA
   POKE p& + 30, &H2
   POKE p& + 31, &H0
'DATA &H55              : 'PUSH BP
'DATA &H8B, &HEC        : 'MOV BP,SP
'DATA &HB8, &H00, &HA0  : 'MOV AX, &HA000
'DATA &H8E, &HC0        : 'MOV ES, AX
'DATA &HB9, &H?,  &H?   : 'MOV CX, LEN
'DATA &HBF, &H?,  &H?   : 'MOV DI, START
'DATA &HB8, &H?,  &H?   : 'MOV AX, COL
'DATA &HD1, &HE9        : 'SHR CX, 1
'DATA &HF3, &HAB        : 'REP STOSW
'DATA &HD1, &HD1        : 'RCL CX, 1
'DATA &H83, &HE1, &H01  : 'AND CX, 1
'DATA &HF3, &HAA        : 'REP STOSB
'DATA &H5D              : 'POP BP
'DATA &HCA, &H02, &H00  : 'RET 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
END SUB

SUB vlin (start&, startpag%, leng%, col%)
   DIM asmprog%(25)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55
   POKE p& + 1, &H8B
   POKE p& + 2, &HEC
   POKE p& + 3, &HB8
   POKE p& + 4, &H0
   POKE p& + 5, &HA0
   POKE p& + 6, &H8E
   POKE p& + 7, &HC0
   POKE p& + 8, &HBA
   POKE p& + 9, &HCD
   POKE p& + 10, &H3
   POKE p& + 11, &HB4
   POKE p& + 12, col%
   POKE p& + 13, &HB0
   POKE p& + 14, startpag%
   POKE p& + 15, &HEE
   POKE p& + 16, &HBF
   POKE p& + 17, start& AND 255
   POKE p& + 18, start& \ 256
   POKE p& + 19, &HB9
   POKE p& + 20, leng% AND 255
   POKE p& + 21, leng% \ 256
   POKE p& + 22, &H26
   POKE p& + 23, &H88
   POKE p& + 24, &H25
   POKE p& + 25, &H81
   POKE p& + 26, &HC7
   POKE p& + 27, &H0
   POKE p& + 28, &H4
   POKE p& + 29, &H72
   POKE p& + 30, &H7
   POKE p& + 31, &H83
   POKE p& + 32, &HE9
   POKE p& + 33, &H1
   POKE p& + 34, &H73
   POKE p& + 35, &HF2
   POKE p& + 36, &H72
   POKE p& + 37, &H8
   POKE p& + 38, &HFE
   POKE p& + 39, &HC0
   POKE p& + 40, &HEE
   POKE p& + 41, &H83
   POKE p& + 42, &HE9
   POKE p& + 43, &H1
   POKE p& + 44, &H73
   POKE p& + 45, &HE8
   POKE p& + 46, &H5D
   POKE p& + 47, &HCA
   POKE p& + 48, &H2
   POKE p& + 49, &H0
   CALL ABSOLUTE(0, p&)
   DEF SEG
  
'     55             push bp
'     8b ec          mov bp, sp
'     b8 00 a0       mov ax, 0xa000
'     8e c0          mov es, ax
'     ba cd 03       mov dx, 0x3cd
'     b4 ?           mov ah, 0x88        (col)
'     b0 ?           mov al, 0x88        (startpag)
'     ee             out dx, al
'     bf ?  ?        mov di, 0x8888      (start)
'     b9 ?  ?        mov cx, 0x8888      (leng)
'lab: 26 88 25       mov byte ptr es:[di], ah
'     81 c7 00 04    add di, 1024
'     72 07          jc skp
'     83 e9 01       sub cx, 1
'     73 f2          jnc lab
'     72 08          jc stp
'skp: fe c0          inc al
'     ee             out dx, al
'     83 e9 01       sub cx, 1
'     73 e8          jnc lab
'stp: 5d             pop bp
'     ca 02 00       ret 2

END SUB

SUB vline2 (x&, ydim&, segtemp&, offtemp&, stp%, shadeoffs%)
   DIM asmprog%(31)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55
   POKE p& + 1, &H8B: POKE p& + 2, &HEC
   POKE p& + 3, &HB8: POKE p& + 4, &H0: POKE p& + 5, &HA0
   POKE p& + 6, &H8E: POKE p& + 7, &HC0
   POKE p& + 8, &HBF: POKE p& + 9, x& AND 255: POKE p& + 10, x& \ 256
   POKE p& + 11, &HB9: POKE p& + 12, (ydim& \ stp%) AND 255: POKE p& + 13, (ydim& \ stp%) \ 256
   POKE p& + 14, &HBB: POKE p& + 15, ydim& AND 255: POKE p& + 16, ydim& \ 256
   POKE p& + 17, &HB8: POKE p& + 18, segtemp& AND 255: POKE p& + 19, segtemp& \ 256
   POKE p& + 20, &HBE: POKE p& + 21, offtemp& AND 255: POKE p& + 22, offtemp& \ 256
   POKE p& + 23, &H33: POKE p& + 24, &HD2
   POKE p& + 25, &H1E
   POKE p& + 26, &H8E: POKE p& + 27, &HD8
   POKE p& + 28, &H3E: POKE p& + 29, &H8A: POKE p& + 30, &H4
   POKE p& + 31, &H3E: POKE p& + 32, &H8A: POKE p& + 33, &H20
   POKE p& + 34, &H4: POKE p& + 35, shadeoffs%
   POKE p& + 36, &H80: POKE p& + 37, &HC4: POKE p& + 38, shadeoffs%
   POKE p& + 39, &H26: POKE p& + 40, &H89: POKE p& + 41, &H5
   POKE p& + 42, &H81: POKE p& + 43, &HC7: POKE p& + 44, xres& AND 255: POKE p& + 45, xres& \ 256
   POKE p& + 46, &H81: POKE p& + 47, &HC2: POKE p& + 48, 0: POKE p& + 49, 0
   POKE p& + 50, &H81: POKE p& + 51, &HD6: POKE p& + 52, stp%: POKE p& + 53, 0
   POKE p& + 54, &HE2: POKE p& + 55, &HE4
   POKE p& + 56, &H1F
   POKE p& + 57, &H5D
   POKE p& + 58, &HCA: POKE p& + 59, &H2: POKE p& + 60, &H0
   CALL ABSOLUTE(0, p&)
   DEF SEG

'      55             push bp
'      8b ec          mov bp, sp
'      b8 00 a0       mov ax, 0xa000
'      8e c0          mov es, ax
'      bf ?  ?        mov di, 0x8888   ;x position
'      b9 ?  ?        mov cx, 0x8888   ;leng
'      bb ?  ?        mov bx, 0x8888   ;ydim
'      b8 ?  ?        mov ax, 0x8888   ;seg tempbuf
'      be ?  ?        mov si, 0x8888   ;offset tempbuf
'      33 d2          xor dx, dx
'      1e             push ds
'      8e d8          mov ds, ax
' beg: 3e 8a 04       mov al, byte ptr ds:[si]
'      3e 8a 20       mov ah, byte ptr ds:[bx][si]
'      04 88          add al, 0x88
'      80 c4 88       add ah, 0x88
'      26 89 05       mov word ptr es:[di], ax
'      81 c7 ? ?      add di, 0x8888   ;xres
'      81 c2 ? ?      add dx, 0x8888   ;incr value
'      81 d6 ? 0      adc si, 0x88     ;step
'      e2 e4          loop beg
'      1f             pop ds
'      5d             pop bp
'      ca 02 00       ret 2

END SUB

