DECLARE SUB deleteline (closest%)
DECLARE FUNCTION front% (z1%, z2%)
DECLARE SUB drawlines ()
DECLARE SUB addrandomline ()
CONST MAXLINES = 512

COMMON SHARED lincount%
DIM SHARED linx1&(MAXLINES), linx2&(MAXLINES), liny&(MAXLINES)
DIM SHARED tempbuf%(MAXLINES)

DIM SHARED sortx&(MAXLINES * 2), sortlin%(MAXLINES * 2)

DIM SHARED minisort%(MAXLINES)

SCREEN 12
RANDOMIZE TIMER

lincount% = 0

FOR z% = 0 TO 8
   CALL addrandomline
NEXT z%

DO
   CALL drawlines
  
   DO
      z$ = INKEY$
   LOOP WHILE z$ = ""
  
   IF z$ = CHR$(0) + CHR$(83) THEN  'Delete - remove lowest line not blocked
      IF lincount% > 0 THEN
        
         sortcnt% = 0
         FOR z% = 0 TO lincount% - 1
            sortx&(sortcnt%) = linx1&(z%): sortlin%(sortcnt%) = z%
            sortcnt% = sortcnt% + 1
            sortx&(sortcnt%) = linx2&(z%): sortlin%(sortcnt%) = z%
            sortcnt% = sortcnt% + 1
         NEXT z%

         FOR z% = 1 TO sortcnt% - 1
            FOR zz% = 0 TO z% - 1
               IF sortx&(z%) < sortx&(zz%) THEN
                  SWAP sortx&(z%), sortx&(zz%)
                  SWAP sortlin%(z%), sortlin%(zz%)
               END IF
            NEXT zz%
         NEXT z%
        
         FOR z% = 0 TO lincount% - 1
            tempbuf%(z%) = 0
         NEXT z%

         LOCATE 20, 1
         FOR z% = 0 TO sortcnt% - 1
            bad% = 0
            IF z% > 1 AND z% < sortcnt% - 1 THEN
               IF tempbuf%(sortlin%(z% - 1)) = 1 AND tempbuf%(sortlin%(z%)) = 1 THEN
                  bad% = 1
               END IF
            END IF
           
            minisortcnt% = 0
            FOR zz% = 0 TO lincount% - 1
               IF tempbuf%(zz%) > 0 THEN
                  minisort%(minisortcnt%) = zz%
                  minisortcnt% = minisortcnt% + 1
               END IF
            NEXT zz%
            FOR zz% = 1 TO minisortcnt% - 1
               FOR zzz% = 0 TO zz% - 1
                  IF front%(minisort%(zz%), minisort%(zzz%)) = minisort%(zzz%) THEN
                     SWAP minisort%(zz%), minisort%(zzz%)
                  END IF
               NEXT zzz%
            NEXT zz%
            FOR zz% = 0 TO minisortcnt% - 1
               LOCATE zz% + 18, z% * 4 + 1
               COLOR bad% * 8 + 3
               PRINT minisort%(zz%);
            NEXT zz%
            COLOR 12
            LOCATE 26, z% * 4 + 1: PRINT sortlin%(z%);

            tempbuf%(sortlin%(z%)) = tempbuf%(sortlin%(z%)) XOR 1

         NEXT z%
         DO: LOOP WHILE INKEY$ = ""

            'Slow way
         FOR z% = 0 TO lincount% - 1: tempbuf%(z%) = 0: NEXT z%
         closest% = 0: tempbuf%(0) = 0
         FOR z% = 1 TO lincount% - 1
            IF tempbuf%(z%) = 0 THEN
               frontval% = front%(z%, closest%)
               IF frontval% >= 0 THEN tempbuf%(z%) = 1
               IF frontval% = z% THEN closest% = z%: z% = 0
            END IF
         NEXT z%
     
         CALL deleteline(closest%)
      END IF
   END IF
  
   IF z$ = CHR$(0) + CHR$(82) THEN   'Insert - make new random line
      CALL addrandomline
   END IF

LOOP WHILE z$ <> CHR$(27)

SUB addrandomline
   DO
      linx1&(lincount%) = INT(630 * RND) + 5
      linx2&(lincount%) = INT(630 * RND) + 5
      IF linx1&(lincount%) > linx2&(lincount%) THEN SWAP linx1&(lincount%), linx2&(lincount%)
      liny&(lincount%) = INT(225 * RND) + 5
      bad% = 0
      FOR z% = 0 TO lincount% - 1
         IF ABS(liny&(z%) - liny&(lincount%)) <= 8 THEN
            IF linx1&(z%) <= linx2&(lincount%) + 8 AND linx1&(lincount%) <= linx2&(z%) + 8 THEN
               bad% = 1
            END IF
         END IF
      NEXT z%
   LOOP WHILE bad% = 1

   LINE (linx1&(lincount%), liny&(lincount%) - 1)-(linx2&(lincount%), liny&(lincount%) + 1), 4, BF
   CIRCLE (linx1&(lincount%), liny&(lincount%)), 2, 12
   CIRCLE (linx2&(lincount%), liny&(lincount%)), 2, 12
   lincount% = lincount% + 1

END SUB

SUB deleteline (closest%)
   FOR zx% = 37 TO 200
      LINE (linx1&(closest%), liny&(closest%))-(linx2&(closest%), liny&(closest%)), (zx% AND 1) * 15
      SOUND zx%, .03
   NEXT zx%
   LINE (linx1&(closest%), liny&(closest%) - 1)-(linx2&(closest%), liny&(closest%) + 1), 0, BF
   CIRCLE (linx1&(closest%), liny&(closest%)), 2, 0
   CIRCLE (linx2&(closest%), liny&(closest%)), 2, 0
   CIRCLE (linx1&(closest%), liny&(closest%)), 3, 0
   CIRCLE (linx2&(closest%), liny&(closest%)), 3, 0
   LOCATE liny&(closest%) \ 16 + 1, ((linx1&(closest%) + linx2&(closest%)) \ 2) \ 8 + 1
   PRINT "  ";
       
   linx1&(closest%) = linx1&(lincount% - 1)
   linx2&(closest%) = linx2&(lincount% - 1)
   liny&(closest%) = liny&(lincount% - 1)
   lincount% = lincount% - 1

END SUB

SUB drawlines
   FOR z% = 0 TO lincount% - 1
      LINE (linx1&(z%), liny&(z%) - 1)-(linx2&(z%), liny&(z%) + 1), 4, BF
      CIRCLE (linx1&(z%), liny&(z%)), 3, 12
      CIRCLE (linx2&(z%), liny&(z%)), 3, 12
     
      LOCATE liny&(z%) \ 16 + 1, ((linx1&(z%) + linx2&(z%)) \ 2) \ 8 + 1
      PRINT CHR$(z% \ 10 + 48); CHR$(z% MOD 10 + 48);

   NEXT z%
END SUB

FUNCTION front% (z1%, z2%)
   IF linx1&(z1%) <= linx2&(z2%) AND linx1&(z2%) <= linx2&(z1%) THEN
      IF liny&(z1%) > liny&(z2%) THEN front% = z1% ELSE front% = z2%
   ELSE
      front% = -1
   END IF
END FUNCTION

