#define MAXSPRITES 4096

typedef struct
{
	long x, y, z;
	short x2offs, y2offs;
	short point2;
	char cstat, shade;
	unsigned char xrepeat, yrepeat;
	short picnum, ang, vel, zvel, owner;
	char *extra;
} spritetype;

typedef struct
{
	short life;
} simplemonsttype;

typedef struct
{
	short life;
	short madness;
	short victim;
} complexmonsttype;

spritetype sprite[MAXSPRITES];
simplemonsttype simplemonst[MAXSPRITES];
complexmonsttype complexmonst[MAXSPRITES];

main()
{
	simplemonsttype *simplepointer;
	complexmonsttype *complexpointer;

	long i;

	for(i=0;i<4;i++)
	{
		if (i < 2)
		{
			sprite[i].extra = (char *)&simplemonst[i];
			simplepointer = (simplemonsttype *)sprite[i].extra;
			sprite[i].picnum = 0;

			sprite[i].x = 1+10*i;
			sprite[i].y = 2+10*i;
			simplepointer->life = 4+10*i;
		}
		else
		{
			sprite[i].extra = (char *)&complexmonst[i];
			complexpointer = (complexmonsttype *)sprite[i].extra;
			sprite[i].picnum = 1;

			sprite[i].x = 1+10*i;
			sprite[i].y = 2+10*i;
			complexpointer->life = 4+10*i;
			complexpointer->madness = 5+10*i;
			complexpointer->victim = 6+10*i;
		}
	}
	for(i=0;i<4;i++)
	{
		printf("%d\n",sprite[i].x);
		printf("%d\n",sprite[i].y);

		switch(sprite[i].picnum)
		{
			case 0:
				simplepointer = (simplemonsttype *)sprite[i].extra;
				printf("%d\n",simplepointer->life);
				break;
			case 1:
				complexpointer = (complexmonsttype *)sprite[i].extra;
				printf("%d\n",complexpointer->life);
				printf("%d\n",complexpointer->madness);
				printf("%d\n",complexpointer->victim);
				break;
		}
	}
}
