// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include "build.h"

#pragma aux clearscreen =\
	"mov edi, 000a0000h",\
	"mov ecx, 16000d",\
	"xor eax, eax",\
	"rep stosd",\
	parm [edi][ax]\

#pragma aux readmouse =\
	"mov ax, 11d",\
	"int 33h",\
	"sar cx, 1",\
	"sar dx, 1",\
	"mov mousx, cx",\
	"mov mousy, dx",\

#pragma aux clearvscreen =\
	"mov edi, 000a0000h",\
	"add edi, centeroffset",\
	"mov ecx, scrsize",\
	"shr ecx, 1",\
	"mov eax, 0e3e3e3e3h",\
	"rep stosd",\
	"mov ecx, scrsize",\
	"shr ecx, 1",\
	"mov eax, 84848484h",\
	"rep stosd",\

#pragma aux interruptend =\
	"mov al, 20h",\
	"out 20h, al",\

#pragma aux vlineasm1 =\
	"push ebp",\
	"or dh,dh",\
	"jz vlineskipdraw",\
	"vlinestart1: mov ebp,ecx",\
	"shr ebp,cl",\
	"mov al,byte ptr [ebp+esi]",\
	"add al,dl",\
	"mov [edi], al",\
	"add edi,320",\
	"add ecx,ebx",\
	"sub dh,1",\
	"jnz vlinestart1",\
	"vlineskipdraw: pop ebp",\
	parm [ebx][ecx][dx][esi][edi]\

#pragma aux vlineasm2l =\
	"push ebp",\
	"vlinestart2l: mov ebp,ecx",\
	"shr ebp,cl",\
	"mov al,byte ptr [ebp+ebx]",\
	"add al,dl",\
	"mov byte ptr [edi],al",\
	"add edi,320",\
	"add ecx,vinc1",\
	"sub eax,65536",\
	"jnc vlinestart2l",\
	"pop ebp",\
	"mov vplc1, ecx",\
	"mov pplc, edi",\
	parm [eax][ebx][ecx][edx][esi][edi]\

#pragma aux vlineasm2r =\
	"push ebp",\
	"vlinestart2r: mov ebp,edx",\
	"shr ebp,cl",\
	"mov al,byte ptr [ebp+esi]",\
	"add al,dl",\
	"mov byte ptr [edi+1],al",\
	"add edi,320",\
	"add edx,vinc2",\
	"sub eax,65536",\
	"jnc vlinestart2r",\
	"pop ebp",\
	"mov vplc2, edx",\
	"mov pplc, edi",\
	parm [eax][ebx][ecx][edx][esi][edi]\

#pragma aux vlineasm2b =\
	"push ebp",\
	"vlinestart2b: mov ebp,ecx",\
	"shr ebp,cl",\
	"mov al,byte ptr [ebp+ebx]",\
	"add al,dl",\
	"mov ebp,edx",\
	"shr ebp,cl",\
	"mov ah,byte ptr [ebp+esi]",\
	"add ah,dl",\
	"mov word ptr [edi],ax",\
	"add edi,320",\
	"add ecx,vinc1",\
	"add edx,vinc2",\
	"sub eax,65536",\
	"jnc vlinestart2b",\
	"pop ebp",\
	"mov vplc1, ecx",\
	"mov vplc2, edx",\
	"mov pplc, edi",\
	parm [eax][ebx][ecx][edx][esi][edi]\

#pragma aux vlineasms =\
	"push ebp",\
	"or dh,dh",\
	"jz vlineskipdraw",\
	"vlinestart1: mov ebp,ecx",\
	"shr ebp,cl",\
	"mov al,byte ptr [ebp+esi]",\
	"add al,dl",\
	"mov [edi], al",\
	"add edi,320",\
	"add ecx,ebx",\
	"sub dh,1",\
	"jnz vlinestart1",\
	"vlineskipdraw: pop ebp",\
	parm [ebx][ecx][dx][esi][edi]\

#pragma aux hlineasm64 =\
	"push ebp",\
	"or dl,dl",\
	"jz hlineskipdraw",\
	"hlinestart: add ebx,vinc1",\
	"add edx,esi",\
	"mov ebp,ebx",\
	"shr ebp,26",\
	"shld ebp,edx,6",\
	"add ebx,vinc1",\
	"add edx,esi",\
	"mov al,byte ptr [ecx+ebp]",\
	"mov ebp,ebx",\
	"shr ebp,26",\
	"shld ebp,edx,6",\
	"mov ah,byte ptr [ecx+ebp]",\
	"add al,bl",\
	"add ah,bl",\
	"stosw",\
	"sub dl,1",\
	"jnz hlinestart",\
	"hlineskipdraw: bt eax,16",\
	"jnc endhlineasm",\
	"add ebx,vinc1",\
	"add edx,esi",\
	"mov ebp,ebx",\
	"shr ebp,26",\
	"shld ebp,edx,6",\
	"mov al,byte ptr [ecx+ebp]",\
	"add al,bl",\
	"stosb",\
	"endhlineasm: pop ebp",\
	parm [eax][edi][ebx][edx][ecx][esi]\

#pragma aux hlineasm128 =\
	"push ebp",\
	"or dl,dl",\
	"jz hlineskipdraw",\
	"hlinestart: add ebx,vinc1",\
	"add edx,esi",\
	"mov ebp,ebx",\
	"shr ebp,25",\
	"shld ebp,edx,7",\
	"add ebx,vinc1",\
	"add edx,esi",\
	"mov al,byte ptr [ecx+ebp]",\
	"mov ebp,ebx",\
	"shr ebp,25",\
	"shld ebp,edx,7",\
	"mov ah,byte ptr [ecx+ebp]",\
	"add al,bl",\
	"add ah,bl",\
	"stosw",\
	"sub dl,1",\
	"jnz hlinestart",\
	"hlineskipdraw: bt eax,16",\
	"jnc endhlineasm",\
	"add ebx,vinc1",\
	"add edx,esi",\
	"mov ebp,ebx",\
	"shr ebp,25",\
	"shld ebp,edx,7",\
	"mov al,byte ptr [ecx+ebp]",\
	"add al,bl",\
	"stosb",\
	"endhlineasm: pop ebp",\
	parm [eax][edi][ebx][edx][ecx][esi]\

#pragma aux svlineasm1 =\
	"push ebp",\
	"vlinestart1: mov ebp,ecx",\
	"shr ebp,cl",\
	"mov al,byte ptr [ebp+esi]",\
	"cmp al,255",\
	"je vlineskipdraw",\
	"add al,dl",\
	"mov [edi], al",\
	"vlineskipdraw: add edi,320",\
	"add ecx,ebx",\
	"sub dh,1",\
	"jnz vlinestart1",\
	"pop ebp",\
	parm [ebx][ecx][dx][esi][edi]\

#pragma aux readkey =\
	"in al, 0x60",\
	"mov readch, al",\
	"in al, 0x61",\
	"or al, 0x80",\
	"out 0x61, al",\
	"and al, 0x7f",\
	"out 0x61, al",\

#pragma aux drawrow =\
	"cld",\
	"mov ecx, 80d",\
	"mov esi, offset tempbuf",\
	"mov edi, pplc",\
	"rep movsd",\
	modify [edi esi ecx]\

#pragma aux readrow =\
	"mov ecx, 80d",\
	"mov esi, pplc",\
	"add edi, offset tempbuf",\
	"rep movsd",\
	parm [edi]\
	modify [edi esi ecx]\

void __interrupt __far ksmhandler()
{
	clockspeed++;
	timetakercount[takernum]++;
	interruptend();
}

void __interrupt __far keyhandler()
{
	oldreadch = readch;
	readkey();
	if ((readch|1) == 0xe1)
		extended = 128;
	else
	{
		if (oldreadch != readch)
			keystatus[(readch&127)+extended] = ((readch>>7)^1);
		extended = 0;
	}
	interruptend();
}

drawscreen()
{
	long snx, sny;
	short int i;
	short int px, py, x1, y1, x2, y2, xdir, ydir, scandist, x, y, ox, oy;
	short int incrx, incry, cnt1, cnt2;

	if ((ceilingstat != 1) && (ceilingstat != 3))
		clearvscreen();
	for(i=0;i<xdim;i++)
	{
		umost[i] = 0;
		dmost[i] = ydim;
	}
	for(i=0;i<numlines;i++)
		lin[i].got = 0;
	numhits = xdim;
	snum = 0;
	closestline = 0;
	px = (short int)(posx>>10); py = (short int)(posy>>10);
	incrx = sintable[(ang+256)&2047];
	incry = sintable[(ang+1792)&2047];
	xdir = 1; if (incrx < 0) xdir = -1, incrx = -incrx;
	ydir = 1; if (incry < 0) ydir = -1, incry = -incry;
	x1 = px, y1 = py, x2 = px, y2 = py;
	snx = (long)(posx&1023); if (xdir == 1) snx ^= 1023;
	sny = (long)(posy&1023); if (ydir == 1) sny ^= 1023;
	cnt1 = (short int)((snx*incry - sny*incrx)>>10);
	snx = (long)(posx&1023); if (ydir == -1) snx ^= 1023;
	sny = (long)(posy&1023); if (xdir == 1) sny ^= 1023;
	cnt2 = (short int)((snx*incrx - sny*incry)>>10);
	addbox(px,py), drawlines();
	scandist = 1;
	while ((numhits > 0) && (scandist < maxscandist))
	{
		if (cnt1 < 0)
			cnt1 += incry, x1 += xdir;
		else
			cnt1 -= incrx, y1 += ydir;
		if (cnt2 < 0)
			cnt2 += incrx, x2 -= ydir;
		else
			cnt2 -= incry, y2 += xdir;
		x = x1, y = y1;
		addbox(x,y);
		while ((x != x2) || (y != y2))
		{
			ox = x, oy = y;
			if ((ox >= px) && (oy < py+scandist)) y++;
			if ((ox <= px) && (oy > py-scandist)) y--;
			if ((oy >= py) && (ox > px-scandist)) x--;
			if ((oy <= py) && (ox < px+scandist)) x++;
			addbox(x,y);
		}
		drawlines();
		scandist++;
	}
	if (snum > 0)
	{
		drawsprites();
		takernum = 0;
	}
}

nextpage()
{
	outp(0x3d4,0xc), outp(0x3d5,page<<6);
	page++;
	if (page == 3)
		page = 0;
	outp(0x3cd,page);
}

engineinput()
{
	int i;

	if (vel < 0)
	{
		vel+=(clockspeed>>3)+1;
		if (vel > 0) vel = 0;
	}
	if (vel > 0)
	{
		vel-=(clockspeed>>3)+1;
		if (vel < 0) vel = 0;
	}
	if (svel < 0)
	{
		svel+=(clockspeed>>2)+1;
		if (svel > 0) svel = 0;
	}
	if (svel > 0)
	{
		svel-=(clockspeed>>2)+1;
		if (svel < 0) svel = 0;
	}
	if (hvel < 0)
	{
		hvel+=(clockspeed>>2)+1;
		if (hvel > 0) hvel = 0;
	}
	if (hvel > 0)
	{
		hvel-=(clockspeed>>2)+1;
		if (hvel < 0) hvel = 0;
	}
	if (angvel < 0)
	{
		angvel+=(clockspeed>>1)+1;
		if (angvel > 0) angvel = 0;
	}
	if (angvel > 0)
	{
		angvel-=(clockspeed>>1)+1;
		if (angvel < 0) angvel = 0;
	}
	if (moustat == 1)
		readmouse();
	angvel += mousx;
	vel -= mousy;
	if (keystatus[0x4e] > 0) ceilingstat = 1;
	if (keystatus[0x4a] > 0) ceilingstat = 0;
	if (keystatus[0x9c] > 0) ceilingstat = 2;
	if (keystatus[0x53] > 0) ceilingstat = 3;
	if (keystatus[0x52] > 0) ceilingstat = 4;
	if (keystatus[0x9d] == 0)
	{
		if (keystatus[0xcb] > 0) angvel -= 10;
		if (keystatus[0xcd] > 0) angvel += 10;
	}
	else
	{
		if (keystatus[0xcb] > 0) svel += 6;
		if (keystatus[0xcd] > 0) svel -= 6;
	}
	if (keystatus[0x1e] > 0) hvel -= 6;
	if (keystatus[0x2c] > 0) hvel += 6;
	if (keystatus[0xc8] > 0) vel += 6;
	if (keystatus[0xd0] > 0) vel -= 6;

	if (vel < -16) vel = -16;
	if (vel > 16) vel = 16;
	if (svel < -16) svel = -16;
	if (svel > 16) svel = 16;
	if (hvel < -16) hvel = -16;
	if (hvel > 16) hvel = 16;
	if (angvel < -24) angvel = -24;
	if (angvel > 24) angvel = 24;

	if (keystatus[0x2a] > 0)
	{
		vel += vel;
		svel += svel;
		hvel += hvel;
	}
	if ((keystatus[0x4b]|keystatus[0x4d]|keystatus[0x48]|keystatus[0x50]) != 0)
	{
		if ((keystatus[0x4b] > 0) && (xdim > 8)) xdim -= 8;
		if ((keystatus[0x4d] > 0) && (xdim < 320)) xdim += 8;
		if ((keystatus[0x48] > 0) && (ydim > 8)) ydim -= 8;
		if ((keystatus[0x50] > 0) && (ydim < 200)) ydim += 8;
		if ((vidmode == 0) && ((xdim > 320) || (ydim > 200)))
		{
			vidmode = 1;
			xtotaldim = 360;
			ytotaldim = 240;
		}
		else if ((vidmode == 1) && ((xdim <= 320) && (ydim <= 200)))
		{
			vidmode = 0;
			xtotaldim = 320;
			ytotaldim = 200;
		}
		for(i=0;i<3;i++)
		{
			outp(0x3cd,i);
			clearscreen();
		}
		halfwidth = (xdim>>1);
		eigthwidth = (xdim>>3);
		halfheight = (ydim>>1);
		centeroffset = (long)(((ytotaldim-ydim)>>1)*320) + ((xtotaldim-xdim)>>1);
		scrsize = ((long)(xdim>>2))*320L;
	}
	if (keystatus[0x19] > 0)
	{
		keystatus[0x19] = 0;
		while ((keystatus[0x19] == 0) && (keystatus[1] == 0));
		keystatus[0x19] = 0;
	}
	if (keystatus[88] > 0)
	{
		screencapture();
		keystatus[88] = 0;
	}
	if (angvel != 0)
	{
		ang += ((angvel*clockspeed)>>3);
		ang = (ang+2048)&2047;
	}
	if (vel != 0)
	{
		posx += ((((long)vel)*((long)clockspeed)*sintable[(2560+ang)&2047])>>15);
		posy += ((((long)vel)*((long)clockspeed)*sintable[(2048+ang)&2047])>>15);
	}
	if (svel != 0)
	{
		posx += ((((long)svel)*((long)clockspeed)*sintable[(2048+ang)&2047])>>15);
		posy -= ((((long)svel)*((long)clockspeed)*sintable[(2560+ang)&2047])>>15);
	}
	if (hvel != 0)
	{
		posz += (long)((hvel*clockspeed)<<3);
		if (posz < 0) posz = 0;
		if (posz > 65535) posz = 65535;
	}
	posz = (posz+posz+posz+newposz)>>2;
}

loadtables()
{
	short int fil, i;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&sintable[0],4096);
		read(fil,&tantable[0],4096);
		close(fil);
	}
	return(0);
}

loadpics()
{
	long totpicsiz, offscount, siz;
	short int fil, i;

	if ((fil=open("pics.dat",O_BINARY|O_RDONLY,S_IREAD))==-1)
		return(-1);
	read(fil,&picsiz[0],maxwalls);
	read(fil,&picanm[0],maxwalls);
	totpicsiz = 0L;
	for(i=0;i<maxwalls;i++)
		if (picsiz[i] > 0)
			totpicsiz += (1<<((long)((picsiz[i]&15)+(picsiz[i]>>4))));
	pic = (char *)malloc(totpicsiz);
	offscount = 0L;
	for(i=0;i<maxwalls;i++)
	{
		waloff[i] = offscount+FP_OFF(pic);
		if (picsiz[i] > 0)
		{
			siz = (1<<((long)((picsiz[i]&15)+(picsiz[i]>>4))));
			read(fil,&pic[offscount],siz);
			offscount += siz;
		}
	}
	close(fil);
	return(0);
}

vline(x, y1, y2, siz, walnume, picplc, shadeoffs)
short int x, walnume, picplc;
long y1, y2, siz;
unsigned char shadeoffs;
{
	unsigned char shiftval;
	short int thesiz, i, y1v, y2v, sizv;
	unsigned long vinc, vplc, p;

	y1v = ((short)(y1>>16));
	y2v = ((short)(y2>>16));
	sizv = ((short)(siz>>16));
	thesiz = y2v-y1v;
	if ((y1v > dmost[x]) || (y2v < umost[x]) || (thesiz <= 0) || (sizv <= 0) || (picsiz[walnume] == 0))
		return(0);
	takernum = 5;

	picplc &= ((0xffff>>(16-(picsiz[walnume]&15)))<<(picsiz[walnume]>>4));
	vinc = ((33554432L*32L) / (siz>>11));
	vplc = (((long)picplc)<<16)+(((y1&65535^65535)*(vinc>>8))>>8);
	if (y1v < umost[x])
	{
		vplc += ((long)(umost[x]-y1v))*vinc;
		y1v = umost[x];
	}
	if (y2v > dmost[x]) y2v = dmost[x];
	thesiz = y2v-y1v;
	if ((thesiz < 1) || (thesiz > ydim))
		return(-1);

	if (((char)(vinc>>16)) < 8)
		shadeoffs -= (char)(vinc>>16);
	else
		shadeoffs -= 8;

	shiftval = 32-(picsiz[walnume]>>4);
	vplc <<= (shiftval-16);
	vinc <<= (shiftval-16);
	p = ((long)(y1v*320+x))+0x000a0000+centeroffset;
	takernum = 6;
	vlineasm1(vinc&0xffffff00,(vplc&0xffffff00)|shiftval,(thesiz<<8)+shadeoffs,picplc+waloff[walnume],p);
	takernum = 4;
	return(0);
}

vline2(x, y1, y2, y3, y4, siz1, siz2, walnume, picplc1, picplc2, shadeoffs)
short int x, walnume, picplc1, picplc2;
long y1, y2, y3, y4, siz1, siz2;
unsigned char shadeoffs;
{
	unsigned char shiftval;
	short int thesiz1, thesiz2, doubsiz, y1v, y2v, y3v, y4v, siz1v, siz2v;
	unsigned long picoffs1, picoffs2;

	y1v = ((short)(y1>>16));
	y2v = ((short)(y2>>16));
	y3v = ((short)(y3>>16));
	y4v = ((short)(y4>>16));
	siz1v = ((short)(siz1>>16));
	siz2v = ((short)(siz2>>16));
	thesiz1 = y2v-y1v;
	thesiz2 = y4v-y3v;
	if ((y1v > dmost[x]) || (y2v < umost[x]) || (thesiz1 <= 0) || (siz1v <= 0) || (picsiz[walnume] == 0))
	{
		vline(x+1,y3,y4,siz2,walnume,picplc2,shadeoffs);
		return(0);
	}
	if ((y3v > dmost[x+1]) || (y4v < umost[x+1]) || (thesiz2 <= 0) || (siz2v <= 0))
	{
		vline(x,y1,y2,siz1,walnume,picplc1,shadeoffs);
		return(0);
	}
	takernum = 5;

	picplc1 &= ((0xffff>>(16-(picsiz[walnume]&15)))<<(picsiz[walnume]>>4));
	vinc1 = ((33554432L*32L) / (siz1>>11));
	vplc1 = (((long)picplc1)<<16)+(((y1&65535^65535)*(vinc1>>8))>>8);
	if (y1v < umost[x])
	{
		vplc1 += ((long)(umost[x]-y1v))*vinc1;
		y1v = umost[x];
	}
	if (y2v > dmost[x]) y2v = dmost[x];
	thesiz1 = y2v-y1v;
	if (thesiz1 < 1)
	{
		vline(x+1,y3,y4,siz2,walnume,picplc2,shadeoffs);
		return(0);
	}

	picplc2 &= ((0xffff>>(16-(picsiz[walnume]&15)))<<(picsiz[walnume]>>4));
	vinc2 = ((33554432L*32L) / (siz2>>11));
	vplc2 = (((long)picplc2)<<16)+(((y3&65535^65535)*(vinc2>>8))>>8);
	if (y3v < umost[x+1])
	{
		vplc2 += ((long)(umost[x+1]-y3v))*vinc2;
		y3v = umost[x+1];
	}
	if (y4v > dmost[x+1]) y4v = dmost[x+1];
	thesiz2 = y4v-y3v;
	if (thesiz2 < 1)
	{
		vline(x,y1,y2,siz1,walnume,picplc1,shadeoffs);
		return(0);
	}

	if (((char)(vinc1>>16)) < 8)
		shadeoffs -= (char)(vinc1>>16);
	else
		shadeoffs -= 8;
	shiftval = 32-(picsiz[walnume]>>4);
	vplc1 <<= (shiftval-16);
	vinc1 <<= (shiftval-16);
	vplc2 <<= (shiftval-16);
	vinc2 <<= (shiftval-16);
	vplc1 += shiftval;
	vplc2 += shadeoffs;
	picoffs1 = (long)picplc1+waloff[walnume];
	picoffs2 = (long)picplc2+waloff[walnume];

	if (y1v < y3v)
	{
		pplc = ((long)(y1v*320+x))+0x000a0000+centeroffset;
		if (y2v < y4v)
			doubsiz = y2v-y3v;
		else
			doubsiz = y4v-y3v;
	}
	else
	{
		pplc = ((long)(y3v*320+x))+0x000a0000+centeroffset;
		if (y2v < y4v)
			doubsiz = y2v-y1v;
		else
			doubsiz = y4v-y1v;
	}
	takernum = 6;
	if (y1v < y3v)
		vlineasm2l(((long)(y3v-y1v-1))<<16,picoffs1,vplc1,vplc2,picoffs2,pplc);
	if (y1v > y3v)
		vlineasm2r(((long)(y1v-y3v-1))<<16,picoffs1,vplc1,vplc2,picoffs2,pplc);
	if (doubsiz > 1)
		vlineasm2b(((long)doubsiz-1)<<16,picoffs1,vplc1,vplc2,picoffs2,pplc);
	if (y2v < y4v)
		vlineasm2r(((long)(y4v-y2v-1))<<16,picoffs1,vplc1,vplc2,picoffs2,pplc);
	if (y2v > y4v)
		vlineasm2l(((long)(y2v-y4v-1))<<16,picoffs1,vplc1,vplc2,picoffs2,pplc);
	takernum = 4;
	return(0);
}

hline (xl, xr, yp, zd, walnume, shadeoffs)
unsigned short int xl, xr, yp, zd;
short int walnume;
char shadeoffs;
{
	short int i, siz;
	long hd, x, y, xc, yc;

	if ((yp == halfheight) || (picsiz[walnume] == 0))
		return(-1);
	if (xl > xr)
		i = xl, xl = xr, xr = i;
	siz = xr-xl+1;
	takernum = 7;
	hd = (((long)zd)<<14)/((long)(xtotaldim*abs(halfheight-yp)));
	xc = (hd*(long)sintable[(2048+ang)&2047])>>2;
	yc = (hd*(long)sintable[(2560+ang)&2047])>>2;
	x = xc*(long)xl - (xc+yc)*(long)halfwidth - (posx<<22);
	y = yc*(long)xl + (xc-yc)*(long)halfwidth + (posy<<22);
	if (yp > halfheight)
	{
		y ^= 0xffffffff;
		yc ^= 0xffffffff;
	}
	if ((hd>>13) < 8)
		shadeoffs -= (char)(hd>>13);
	else
		shadeoffs -= 8;
	vinc1 = (xc&0xffffff00);
	takernum = 8;
	if ((picsiz[walnume]&15) == 6)
		hlineasm64(((long)(siz&1))<<16,((long)(yp*320+xl))+0x000a0000+centeroffset,(x&0xffffff00)|shadeoffs,(y&0xffffff00)|(siz>>1),waloff[walnume],yc&0xffffff00);
	else if ((picsiz[walnume]&15) == 7)
		hlineasm128(((long)(siz&1))<<16,((long)(yp*320+xl))+0x000a0000+centeroffset,(x&0xffffff00)|shadeoffs,(y&0xffffff00)|(siz>>1),waloff[walnume],yc&0xffffff00);
	takernum = 4;
	return(0);
}

loadboard()
{
	long zx, templong, clipx, clipy, xz, yz, oldxz, oldyz;
	long xa1v, xa2v, ya1v, ya2v;
	short int fil, i, j, gap, temp, tempword;
	char tempchar;

	if ((fil = open("boards.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&i,2), posx = (((long)i)<<5);
		read(fil,&i,2), posy = (((long)i)<<5);
		read(fil,&ang,2);
		read(fil,&numlines,2);
		read(fil,&tempbuf[0],numlines<<1);
		for(i=0;i<numlines;i++)
			lin[i].xa1 = (((unsigned short)tempbuf[i+i]+(((unsigned short)tempbuf[i+i+1])<<8))<<5);
		read(fil,&tempbuf[0],numlines<<1);
		for(i=0;i<numlines;i++)
			lin[i].ya1 = (((unsigned short)tempbuf[i+i]+(((unsigned short)tempbuf[i+i+1])<<8))<<5);
		read(fil,&tempbuf[0],numlines<<1);
		for(i=0;i<numlines;i++)
			lin[i].xa2 = (((unsigned short)tempbuf[i+i]+(((unsigned short)tempbuf[i+i+1])<<8))<<5);
		read(fil,&tempbuf[0],numlines<<1);
		for(i=0;i<numlines;i++)
			lin[i].ya2 = (((unsigned short)tempbuf[i+i]+(((unsigned short)tempbuf[i+i+1])<<8))<<5);
		read(fil,&tempbuf[0],numlines<<1);
		for(i=0;i<numlines;i++)
			lin[i].picnum = (unsigned short)tempbuf[i+i]+(((unsigned short)tempbuf[i+i+1])<<8);
		read(fil,&tempbuf[0],numlines<<1);
		for(i=0;i<numlines;i++)
			lin[i].picnum1 = (unsigned short)tempbuf[i+i]+(((unsigned short)tempbuf[i+i+1])<<8);
		read(fil,&tempbuf[0],numlines<<1);
		for(i=0;i<numlines;i++)
			lin[i].picnum2 = (unsigned short)tempbuf[i+i]+(((unsigned short)tempbuf[i+i+1])<<8);
		read(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			lin[i].shade = tempbuf[i];
		read(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			lin[i].shade1 = tempbuf[i];
		read(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			lin[i].shade2 = tempbuf[i];
		read(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			lin[i].z1 = tempbuf[i];
		read(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			lin[i].z2 = tempbuf[i];
		read(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			lin[i].cstat = tempbuf[i];
		read(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			lin[i].zosc = tempbuf[i];
		read(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			lin[i].repeat = tempbuf[i];
		close(fil);
		gap = (numlines>>1);
		do
		{
			for(i=0;i<numlines-gap;i++)
			{
				temp = i;
				while ((lin[temp].xa1 > lin[temp+gap].xa1) && (temp >= 0))
				{
					tempword = lin[temp].xa1; lin[temp].xa1 = lin[temp+gap].xa1; lin[temp+gap].xa1 = tempword;
					tempword = lin[temp].ya1; lin[temp].ya1 = lin[temp+gap].ya1; lin[temp+gap].ya1 = tempword;
					tempword = lin[temp].xa2; lin[temp].xa2 = lin[temp+gap].xa2; lin[temp+gap].xa2 = tempword;
					tempword = lin[temp].ya2; lin[temp].ya2 = lin[temp+gap].ya2; lin[temp+gap].ya2 = tempword;
					tempword = lin[temp].picnum; lin[temp].picnum = lin[temp+gap].picnum; lin[temp+gap].picnum = tempword;
					tempword = lin[temp].picnum1; lin[temp].picnum1 = lin[temp+gap].picnum1; lin[temp+gap].picnum1 = tempword;
					tempword = lin[temp].picnum2; lin[temp].picnum2 = lin[temp+gap].picnum2; lin[temp+gap].picnum2 = tempword;
					tempchar = lin[temp].shade; lin[temp].shade = lin[temp+gap].shade; lin[temp+gap].shade = tempchar;
					tempchar = lin[temp].shade1; lin[temp].shade1 = lin[temp+gap].shade1; lin[temp+gap].shade1 = tempchar;
					tempchar = lin[temp].shade2; lin[temp].shade2 = lin[temp+gap].shade2; lin[temp+gap].shade2 = tempchar;
					tempchar = lin[temp].z1; lin[temp].z1 = lin[temp+gap].z1; lin[temp+gap].z1 = tempchar;
					tempchar = lin[temp].z2; lin[temp].z2 = lin[temp+gap].z2; lin[temp+gap].z2 = tempchar;
					tempchar = lin[temp].got; lin[temp].got = lin[temp+gap].got; lin[temp+gap].got = tempchar;
					tempchar = lin[temp].cstat; lin[temp].cstat = lin[temp+gap].cstat; lin[temp+gap].cstat = tempchar;
					tempchar = lin[temp].zosc; lin[temp].zosc = lin[temp+gap].zosc; lin[temp+gap].zosc = tempchar;
					tempchar = lin[temp].repeat; lin[temp].repeat = lin[temp+gap].repeat; lin[temp+gap].repeat = tempchar;
					temp -= gap;
				}
			}
			gap >>= 1;
		}
		while (gap > 0);
		for(i=0;i<=4096;i++)
			lintaladdr[i] = 0;
		for(i=0;i<64;i++)
			tempbuf[i] = 0;
		lintalcnt = 0;
		for(i=0;i<numlines;i++)
		{
			xa1v = (long)lin[i].xa1;
			ya1v = (long)lin[i].ya1;
			xa2v = (long)lin[i].xa2;
			ya2v = (long)lin[i].ya2;
			if (xa1v == xa2v)
			{
				if (ya1v > ya2v)
					templong = ya1v, ya1v = ya2v, ya2v = templong;
				for(templong=(ya1v&0xfffffc00);templong<=((ya2v-1)&0xfffffc00);templong+=1024)
					addit((short int)(xa1v>>10),(short int)(templong>>10),i);
				if ((ya1v == ya2v) && ((ya1v&1023) == 0))
					addit((short int)(xa1v>>10),(short int)(ya1v>>10),i);
			}
			else if (ya1v == ya2v)
			{
				if (xa1v > xa2v)
					templong = xa1v, xa1v = xa2v, xa2v = templong;
				for(templong=(xa1v&0xfffffc00);templong<=((xa2v-1)&0xfffffc00);templong+=1024)
					addit((short int)(templong>>10),(short int)(ya1v>>10),i);
				if ((xa1v == xa2v) && ((xa1v&1023) == 0))
					addit((short int)(xa1v>>10),(short int)(ya1v>>10),i);
			}
			else
			{
				clipx = -1L, clipy = -1L;
				if ((xa2v > xa1v) && ((xa2v&1023) == 0)) clipx = xa2v;
				if ((ya2v > ya1v) && ((ya2v&1023) == 0)) clipy = ya2v;
				if ((xa1v > xa2v) && ((xa1v&1023) == 0)) clipx = xa1v;
				if ((ya1v > ya2v) && ((ya1v&1023) == 0)) clipy = ya1v;
				xz = xa1v, yz = ya1v;
				if ((xz != clipx) && (yz != clipy))
					addit((short int)(xz>>10),(short int)(yz>>10),i);
				for(zx=1;zx<=8;zx++)
				{
					oldxz = xz, oldyz = yz;
					xz = (((xa2v*zx) + (xa1v*(8-zx)))>>3);
					yz = (((ya2v*zx) + (ya1v*(8-zx)))>>3);
					if (((xz|1023) != (oldxz|1023)) || ((yz|1023) != (oldyz|1023)))
						if ((xz != clipx) && (yz != clipy))
							addit((short int)(xz>>10),(short int)(yz>>10),i);
				}
			}
		}
		for(i=1;i<=4096;i++)
			lintaladdr[i] = lintaladdr[i-1] + lintaladdr[i];
	}
	return(0);
}

addit(x,y,i)
short int x, y, i;
{
	short int p, hereplc, zz;

	p = (x<<6) + y + 1;
	hereplc = 0;
	for(zz=0;zz<x;zz++)
		hereplc += tempbuf[zz];
	for(zz=(x<<6)+1;zz<p;zz++)
		hereplc += lintaladdr[zz];
	for(zz=lintalcnt;zz>hereplc;zz--)
		lintal[zz] = lintal[zz-1];
	lintaladdr[p]++;
	tempbuf[x]++;
	lintal[hereplc] = i;
	lintalcnt++;
	return(0);
}

short int infront(l1, l2)
short int l1, l2;
{
	short int danger;
	long tempheight, temp1, temp2;

	if ((yb1[l1] < yb1[l2]) == (yb1[l1] < yb2[l2]))
		if ((yb2[l1] < yb1[l2]) == (yb2[l1] < yb2[l2]))
			if ((yb1[l1] < yb1[l2]) == (yb2[l1] < yb1[l2]))
			{
				if (yb1[l1]+yb2[l1] > yb1[l2]+yb2[l2])
					return(0);
				else
					return(1);
			}
	if ((xb1[l1] == xb2[l1]) && (xb2[l1] == xb2[l2]))
	{
		if (yb1[l1] > yb1[l2]) return(0);
		if (yb1[l1] < yb1[l2]) return(1);
		if (yb2[l1] > yb2[l2]) return(0);
		if (yb2[l1] < yb2[l2]) return(1);
		return(-1);
	}
	danger = 0;
	if ((xb1[l1] == xb1[l2]) && (yb1[l1] == yb1[l2])) danger |= 1;
	if ((xb2[l1] == xb2[l2]) && (yb2[l1] == yb2[l2])) danger |= 2;
	if ((xb1[l1] <= xb2[l2]) && (xb1[l1] >= xb1[l2]) && ((danger&1) == 0))
	{
		temp1 = ((xb1[l2]-xb1[l1])*yb1[l2])>>4;
		temp2 = ((xb2[l2]-xb1[l1])*yb2[l2])>>4;
		if (temp1 != temp2)
		{
			tempheight = yb1[l2] - ((yb2[l2]-yb1[l2])*temp1)/(temp2-temp1);
			if (tempheight > yb1[l1])
				return(1);
			else
				return(0);
		}
	}
	if ((xb1[l2] <= xb2[l1]) && (xb1[l2] >= xb1[l1]) && ((danger&1) == 0))
	{
		temp1 = ((xb1[l1]-xb1[l2])*yb1[l2])>>4;
		temp2 = ((xb2[l1]-xb1[l2])*yb2[l2])>>4;
		if (temp1 != temp2)
		{
			tempheight = yb1[l1] - ((yb2[l1]-yb1[l1])*temp1)/(temp2-temp1);
			if (tempheight > yb1[l2])
				return(0);
			else
				return(1);
		}
	}
	if ((xb2[l1] <= xb2[l2]) && (xb2[l1] >= xb1[l2]) && ((danger&2) == 0))
	{
		temp1 = ((xb2[l2]-xb2[l1])*yb2[l2])>>4;
		temp2 = ((xb1[l2]-xb2[l1])*yb1[l2])>>4;
		if (temp1 != temp2)
		{
			tempheight = yb2[l2] - ((yb1[l2]-yb2[l2])*temp1)/(temp2-temp1);
			if (tempheight > yb2[l1])
				return(1);
			else
				return(0);
		}
	}
	if ((xb2[l2] <= xb2[l1]) && (xb2[l2] >= xb1[l1]) && ((danger&2) == 0))
	{
		temp1 = ((xb2[l1]-xb2[l2])*yb2[l1])>>4;
		temp2 = ((xb1[l1]-xb2[l2])*yb1[l1])>>4;
		if (temp1 != temp2)
		{
			tempheight = yb2[l1] - ((yb1[l1]-yb2[l1])*temp1)/(temp2-temp1);
			if (tempheight > yb2[l2])
				return(0);
			else
				return(1);
		}
	}
	return(-1);
}

loadintroscreen()
{
	short int fil, i;

	if ((fil = open("build.bmp",O_BINARY|O_RDWR,S_IREAD)) == -1)
		exit(-1);
	read(fil,&tempbuf[0],54);
	read(fil,&tempbuf[0],1024);
	outp(0x3c8,0);
	for(i=0;i<1024;i++)
		if ((i&3) != 0)
			outp(0x3c9,tempbuf[i^3]>>2);
	pplc = 0x000a0000+64000L-320L;
	for(i=0;i<200;i++)
	{
		read(fil,&tempbuf[0],320);
		drawrow();
		pplc -= 320L;
	}
	close(fil);
	return(0);
}

screencapture()
{
	char filename[15];
	short int fil;
	long i, j, k, bufplc;

	strcpy(filename,"capturxx.bmp");
	filename[6] = (capturecount/10)+48;
	filename[7] = (capturecount%10)+48;
	capturecount++;
	if ((fil=open(filename,O_BINARY|O_CREAT|O_WRONLY,S_IWRITE))==-1)
	{
		capturecount--;
		return(-1);
	}
	tempbuf[0] = 66, tempbuf[1] = 77, tempbuf[2] = 90, tempbuf[3] = 34;
	tempbuf[4] = 0, tempbuf[5] = 0, tempbuf[6] = 0, tempbuf[7] = 0;
	tempbuf[8] = 0, tempbuf[9] = 0, tempbuf[10] = 26, tempbuf[11] = 3;
	tempbuf[12] = 0, tempbuf[13] = 0, tempbuf[14] = 12, tempbuf[15] = 0;
	tempbuf[16] = 0, tempbuf[17] = 0, tempbuf[18] = 64, tempbuf[19] = 1;
	tempbuf[20] = 200, tempbuf[21] = 0, tempbuf[22] = 1, tempbuf[23] = 0;
	tempbuf[24] = 8, tempbuf[25] = 0;
	write(fil,&tempbuf[0],26);
	outp(0x3c7,0);
	for(i=0;i<768;i++)
		tempbuf[i] = (inp(0x3c9)<<2);
	for(i=0;i<768;i+=3)
	{
		j = tempbuf[i];
		tempbuf[i] = tempbuf[i+2];
		tempbuf[i+2] = j;
	}
	if (write(fil,&tempbuf[0],768) < 768)
	{
		close(fil);
		capturecount--;
		return(-1);
	}

	bufplc = 0L;
	for(j=199;j>=0;j--)
	{
		outp(97,inp(97)|3);
		pplc = 0x000a0000+j*320;
		readrow(bufplc);
		bufplc += 320L;
		if (bufplc >= 3200L)
		{
			if (write(fil,&tempbuf[0],3200) < 3200)
			{
				close(fil);
				capturecount--;
				return(-1);
			}
			bufplc = 0L;
		}
		outp(97,inp(97)&252);
	}
	close(fil);
	return(0);
}

addbox(x,y)
short int x,y;
{
	short int p;
	long templong, templong1, xp1, yp1, xp2, yp2;
	short int i, j, k, good;

	p = ((x&63)<<6)+(y&63);
	if (lintaladdr[p] == lintaladdr[p+1])
		return(0);
	takernum = 1;
	for(i=lintaladdr[p];i<lintaladdr[p+1];i++)
	{
		if (lin[lintal[i]].got == 0)
		{
			lin[lintal[i]].got = 1;
			xp1 = (((long)(lin[lintal[i]].xa1-posx)*(long)sintable[(2048+ang)&2047]-(long)(lin[lintal[i]].ya1-posy)*(long)sintable[(2560+ang)&2047])>>15);
			yp1 = (((long)(lin[lintal[i]].xa1-posx)*(long)sintable[(2560+ang)&2047]+(long)(lin[lintal[i]].ya1-posy)*(long)sintable[(2048+ang)&2047])>>15);
			xp2 = (((long)(lin[lintal[i]].xa2-posx)*(long)sintable[(2048+ang)&2047]-(long)(lin[lintal[i]].ya2-posy)*(long)sintable[(2560+ang)&2047])>>15);
			yp2 = (((long)(lin[lintal[i]].xa2-posx)*(long)sintable[(2560+ang)&2047]+(long)(lin[lintal[i]].ya2-posy)*(long)sintable[(2048+ang)&2047])>>15);
			good = 7;
			if ((labs(xp1) <= yp1) && (yp1 > 0)) good--;
			if ((labs(xp2) <= yp2) && (yp2 > 0)) good-=2;
			if ((good == 7) && ((yp1 > 0) || (yp2 > 0)) && ((xp1 < 0) == (0 < xp2)))
				good = 3;
			yb1[lintalplc] = -1;
			yb2[lintalplc] = -1;
			if (good < 7)
			{
				if ((good&3) > 0)
					templong = xp2*yp1-xp1*yp2;
				if ((good&1) == 0)
				{
					if (yp1 != 0)
						xb1[lintalplc] = ((long)halfwidth)-((xp1*((long)halfwidth))/yp1);
					yb1[lintalplc] = yp1;
				}
				else
				{
					j = 0;
					if (xp1 > 0) j = 1;
					if (((xp1 < 0) == (0 < xp2)) && ((yp1 < 0) == (0 < yp2)))
						if (labs(xp1*yp2) < labs(xp2*yp1)) j = 1;
					if (j == 0)
					{
						xb1[lintalplc] = (long)(xdim-1);
						templong1 = yp2-yp1+xp2-xp1;
						if (templong1 != 0)
							yb1[lintalplc] = templong/templong1;
					}
					else
					{
						xb1[lintalplc] = 0L;
						templong1 = yp1-yp2+xp2-xp1;
						if (templong1 != 0)
							yb1[lintalplc] = templong/templong1;
					}
				}
				if ((good&2) == 0)
				{
					if (yp2 != 0)
						xb2[lintalplc] = ((long)halfwidth)-((xp2*((long)halfwidth))/yp2);
					yb2[lintalplc] = yp2;
				}
				else
				{
					j = 0;
					if (xp2 > 0) j = 1;
					if (((xp1 < 0) == (0 < xp2)) && ((yp1 < 0) == (0 < yp2)))
						if (labs(xp2*yp1) < labs(xp1*yp2)) j = 0;
					if (j == 0)
					{
						xb2[lintalplc] = (long)(xdim-1);
						templong1 = yp2-yp1+xp2-xp1;
						if (templong1 != 0)
							yb2[lintalplc] = templong/templong1;
					}
					else
					{
						xb2[lintalplc] = 0L;
						templong1 = yp1-yp2+xp2-xp1;
						if (templong1 != 0)
							yb2[lintalplc] = templong/templong1;
					}
				}
			}
			theline[lintalplc] = lintal[i];
			swapped[lintalplc] = 0;
			if (xb1[lintalplc] > xb2[lintalplc])
			{
				templong = xb1[lintalplc]; xb1[lintalplc] = xb2[lintalplc]; xb2[lintalplc] = templong;
				templong = yb1[lintalplc]; yb1[lintalplc] = yb2[lintalplc]; yb2[lintalplc] = templong;
				swapped[lintalplc] = 1;
			}
			if ((yb1[lintalplc] > 0L) && (yb2[lintalplc] > 0L) && ((xb1[lintalplc] != xb2[lintalplc]) || ((lin[lintal[i]].cstat&15) == 0)))
				if (((lin[lintal[i]].cstat&15) != 3) || (swapped[lintalplc] == 0))
					lintalplc++;
		}
	}
	takernum = 0;
	return(0);
}

drawlines()
{
	unsigned char tempchar, theshade, z1v, z2v;
	unsigned short int thez, dztop, dzbot, picn[3];
	long templong, templong1, templong2, dztoplong, dzbotlong;
	long x2, y2, x3, y3, top, bot, topinc, botinc, uplc, dplc;
	long hc1, hc2, hc3, hi1, hi2, hi3, yn1, yn2;
	long xa1v, ya1v, xa2v, ya2v, yh1, yh2, yh3, yh4, llinum, rlinum;
	short int theplc, theceilpic, daline;
	short int i, j, k, m, n, o, good, gap;
	short int um, dm, up, dp;
	short int temp, closest;

	if (lintalplc == 0)
		return(0);
	takernum = 2;
	gap = (lintalplc>>1);
	while (gap > 0)
	{
		for(i=0;i<lintalplc-gap;i++)
		{
			temp = i;
			if (yb1[temp] < yb2[temp]) templong1 = yb1[temp]; else templong1 = yb2[temp];
			if (yb1[temp+gap] < yb2[temp+gap]) templong2 = yb1[temp+gap]; else templong2 = yb2[temp+gap];
			while (templong1 > templong2)
			{
				templong = xb1[temp]; xb1[temp] = xb1[temp+gap]; xb1[temp+gap] = templong;
				templong = yb1[temp]; yb1[temp] = yb1[temp+gap]; yb1[temp+gap] = templong;
				templong = xb2[temp]; xb2[temp] = xb2[temp+gap]; xb2[temp+gap] = templong;
				templong = yb2[temp]; yb2[temp] = yb2[temp+gap]; yb2[temp+gap] = templong;
				j = theline[temp]; theline[temp] = theline[temp+gap]; theline[temp+gap] = j;
				tempchar = swapped[temp]; swapped[temp] = swapped[temp+gap]; swapped[temp+gap] = tempchar;
				temp -= gap;
				if (temp < 0)
					break;
				if (yb1[temp] < yb2[temp]) templong1 = yb1[temp]; else templong1 = yb2[temp];
				if (yb1[temp+gap] < yb2[temp+gap]) templong2 = yb1[temp+gap]; else templong2 = yb2[temp+gap];
			}
		}
		gap >>= 1;
	}
	for(i=0;i<lintalplc;i++)
	{
		takernum = 2;
		closest = i;
		do
		{
			good = 0;
			if (lin[theline[closest]].z2 >= uzmost[xb1[closest]+1]) good = 1;
			if (lin[theline[closest]].z1 <= dzmost[xb1[closest]+1]) good = 1;
			if (lin[theline[closest]].z2 >= uzmost[xb2[closest]-1]) good = 1;
			if (lin[theline[closest]].z1 <= dzmost[xb2[closest]-1]) good = 1;
			if (good == 0)
				closest++;
		}
		while ((good == 0) && (closest < lintalplc));
		if (closest >= lintalplc)
		{
			i = lintalplc;
			numhits = 0;
			break;
		}
		m = 1;
		n = 0;
		while ((m == 1) && (n < (lintalplc-i)))
		{
			m = 0;
			n++;
			for(j=i+1;j<lintalplc;j++)
			{
				if ((lin[theline[j]].z2 >= uzmost[xb1[j]+1]) || (lin[theline[j]].z1 <= dzmost[xb1[j]+1]) || (lin[theline[j]].z2 >= uzmost[xb2[j]-1]) || (lin[theline[j]].z1 <= dzmost[xb2[j]-1]))
					if ((xb1[j] <= xb2[closest]) && (xb1[closest] <= xb2[j]))
					{
						m = infront(j,closest);
						if (m == 0)
						{
							if ((lin[theline[closest]].cstat&15) == 3)
								if ((xb1[j] >= xb1[closest]) && (xb2[j] <= xb2[closest]))
								{
									lintalplc--;
									xb1[j] = xb1[lintalplc];
									yb1[j] = yb1[lintalplc];
									xb2[j] = xb2[lintalplc];
									yb2[j] = yb2[lintalplc];
									theline[j] = theline[lintalplc];
									swapped[j] = swapped[lintalplc];
									if (closest == lintalplc) closest = j;
								}
						}
						if (m == 1)
						{
							closest = j;
							break;
						}
					}
			}
			if (closest != i)
			{
				templong = xb1[i]; xb1[i] = xb1[closest]; xb1[closest] = templong;
				templong = yb1[i]; yb1[i] = yb1[closest]; yb1[closest] = templong;
				templong = xb2[i]; xb2[i] = xb2[closest]; xb2[closest] = templong;
				templong = yb2[i]; yb2[i] = yb2[closest]; yb2[closest] = templong;
				m = theline[i]; theline[i] = theline[closest]; theline[closest] = m;
				tempchar = swapped[i]; swapped[i] = swapped[closest]; swapped[closest] = tempchar;
			}
			if ((lin[theline[i]].cstat&15) == 0)
			{
				if (snum < maxsprites-1)
				{
					xs[snum] = xb1[i];
					dztoplong = posz-(((long)lin[theline[i]].z1+lin[theline[i]].z2)<<7);
					templong1 = ((long)xtotaldim)*yb1[i];
					ys[snum] = ((long)halfheight)-((dztoplong*((long)xdim)<<2)/templong1);
					sizs[snum] = ((65536L/yb1[i])*((long)xdim))/((long)xtotaldim);
					sline[snum] = theline[i];
					for(j=0;j<320;j++)
					{
						sumost[snum][j] = (char)umost[j];
						sdmost[snum][j] = (char)dmost[j];
					}
					snum++;
				}
				good = 1;
			}
			else
			{
				good = 1;
				for(j=xb1[i];j<=xb2[i];j++)
					if (umost[j] < dmost[j])
						good = 0;
			}
			if (good == 0)
			{
				takernum = 4;
				daline = theline[i];
				z1v = lin[daline].z1;
				z2v = lin[daline].z2;
				if (lin[daline].zosc != 0)
					z1v += (sintable[(numframes<<6)&2047]>>11);
				if (ceilingstat < 3)
				{
					picn[0] = lin[daline].picnum;
					picn[1] = lin[daline].picnum1;
					picn[2] = lin[daline].picnum2;
				}
				else
				{
					picn[0] = 55;
					picn[1] = 54;
					picn[2] = 54;
				}
				for(j=0;j<3;j++)
				{
					if (picanm[picn[j]] != 0)
					{
						if ((picanm[picn[j]]&128) == 0)
							picn[j] += (numframes%(picanm[picn[j]]+1));
						else
						{
							k = (numframes%((255-((short)picanm[picn[j]]))<<1));
							if (k <= (255-((short)picanm[picn[j]])))
								picn[j] += k;
							else
								picn[j] += (((255-((short)picanm[picn[j]]))<<1)-k);
						}
					}
				}
				if ((closestline == 0) && ((lin[daline].cstat&2) > 0))
				{
					if (swapped[i] == 0)
						newposz = (((long)z2v)<<8)-8192L;
					else
						newposz = (((long)z1v)<<8)-8192L;
					closestline = 1;
				}
				dztoplong = posz-(((long)z1v)<<8);
				dzbotlong = posz-(((long)z2v)<<8);
				if ((yb1[i] != 0) && (yb2[i] != 0))
				{
					templong1 = ((long)xtotaldim)*yb1[i];
					templong2 = ((long)xtotaldim)*yb2[i];
					yh1 = ((long)halfheight)-((dztoplong*((long)xdim)<<2)/templong1);
					yh2 = ((long)halfheight)-((dzbotlong*((long)xdim)<<2)/templong1);
					yh3 = ((long)halfheight)-((dztoplong*((long)xdim)<<2)/templong2);
					yh4 = ((long)halfheight)-((dzbotlong*((long)xdim)<<2)/templong2);
					yn1 = 524288L / yb1[i];
					yn2 = 524288L / yb2[i];
				}
				dztop = (unsigned short int)(labs(dztoplong));
				dzbot = (unsigned short int)(labs(dzbotlong));

				uplc = (yh1<<16);
				dplc = (yh2<<16);

				templong = xb2[i]-xb1[i]+1L;
				hi1 = ((yh3-yh1)<<16)/templong;
				hi2 = ((yh4-yh2)<<16)/templong;
				hi3 = ((((yn2-yn1)*((long)xdim))/((long)xtotaldim))<<16)/templong;

				if (swapped[i] == 0)
				{
					um = (short int)(uplc>>16);
					dm = (short int)(dplc>>16)-1;
				}
				else
				{
					um = (short int)(dplc>>16)-1;
					dm = (short int)(uplc>>16);
				}
				up = um-1;
				dp = dm+1;
				if (dmost[xb1[i]]-1 <= up)
				{
					up = dmost[xb1[i]]-1;
					um = up+1;
				}
				if (umost[xb1[i]] >= dp)
				{
					dp = umost[xb1[i]];
					dm = dp-1;
				}
				if (um < -1) um = -1;
				if (dm < -1) dm = -1;
				if (up < -1) up = -1;
				if (dp < -1) dp = -1;
				if (um > ydim) um = ydim;
				if (dm > ydim) dm = ydim;
				if (up > ydim) up = ydim;
				if (dp > ydim) dp = ydim;

				for(j=xb1[i];j<=xb2[i];j++)
				{
					uplace[j] = uplc;
					dplace[j] = dplc;
					uplc += hi1;
					dplc += hi2;
				}
				if ((ceilingstat > 0) && (ceilingstat < 4))
				{
					if ((lin[daline].cstat&1) > 0)
					{
						if (swapped[i] == 0)
							thez = dztop, theceilpic = picn[1], theshade = lin[daline].shade1;
						else
							thez = dzbot, theceilpic = picn[2], theshade = lin[daline].shade2;
						for(j=xb1[i];j<=xb2[i];j++)
						{
							if (swapped[i] == 0)
								theplc = ((short int)(uplace[j]>>16))-1;
							else
								theplc = ((short int)(dplace[j]>>16));
							if (theplc < -1) theplc = -1;
							if (theplc > ydim) theplc = ydim;
							if (theplc > dmost[j]-1) theplc = dmost[j]-1;
							while ((umost[j] > um) && (um < ydim))
							{
								if (uxsave[um+1] >= 0)
								{
									hline(uxsave[um+1],j-1,um,thez,theceilpic,theshade);
									uxsave[um+1] = -1;
								}
								um++;
							}
							while ((theplc < up) && (up >= 0))
							{
								if (uxsave[up+1] >= 0)
								{
									hline(uxsave[up+1],j-1,up,thez,theceilpic,theshade);
									uxsave[up+1] = -1;
								}
								up--;
							}
							while ((umost[j] < um) && (um > 0))
							{
								um--;
								if (up >= um)
									 uxsave[um+1] = j;
							}
							while ((theplc > up) && (up < ydim-1))
							{
								up++;
								if (up >= um)
									uxsave[up+1] = j;
							}
						}
					}
					if ((lin[daline].cstat&2) > 0)
					{
						if (swapped[i] == 0)
							thez = dzbot, theceilpic = picn[2], theshade = lin[daline].shade2;
						else
							thez = dztop, theceilpic = picn[1], theshade = lin[daline].shade1;
						for(j=xb1[i];j<=xb2[i];j++)
						{
							if (swapped[i] == 0)
								theplc = ((short int)(dplace[j]>>16));
							else
								theplc = ((short int)(uplace[j]>>16))-1;
							if (theplc < -1) theplc = -1;
							if (theplc > ydim) theplc = ydim;
							if (theplc < umost[j]) theplc = umost[j];
							while ((dmost[j]-1 < dm) && (dm >= 0))
							{
								if (dxsave[dm+1] >= 0)
								{
									hline(dxsave[dm+1],j-1,dm,thez,theceilpic,theshade);
									dxsave[dm+1] = -1;
								}
								dm--;
							}
							while ((theplc > dp) && (dp < ydim))
							{
								if (dxsave[dp+1] >= 0)
								{
									hline(dxsave[dp+1],j-1,dp,thez,theceilpic,theshade);
									dxsave[dp+1] = -1;
								}
								dp++;
							}
							while ((dmost[j]-1 > dm) && (dm < ydim-1))
							{
								dm++;
								if (dp <= dm)
									dxsave[dm+1] = j;
							}
							while ((theplc < dp) && (dp > 0))
							{
								dp--;
								if (dp <= dm)
									dxsave[dp+1] = j;
							}
						}
					}
				}
				if ((ceilingstat != 2) && (swapped[i] == 0) && (z1v < z2v))
				{
					takernum = 5;

					xa1v = (long)lin[daline].xa1;
					ya1v = (long)lin[daline].ya1;
					xa2v = (long)lin[daline].xa2;
					ya2v = (long)lin[daline].ya2;
					tempchar = (picsiz[picn[0]]&15)+(picsiz[picn[0]]>>4);
					hc3 = ((((long)((yn1*xdim)))/xtotaldim)<<16);

					x3 = (((long)((xdim>>1)-xb1[i]))<<19)/(yn1*(xdim>>3));
					y3 = (2097152L/yn1);
					x2 = posx-((x3*sintable[(2048-ang)&2047] - y3*sintable[(2560-ang)&2047])>>15);
					y2 = posy-((x3*sintable[(2560-ang)&2047] + y3*sintable[(2048-ang)&2047])>>15);
					if (labs(xa1v-xa2v) >= labs(ya1v-ya2v))
						llinum = ((labs(xa1v-x2))<<tempchar)/labs(xa2v-xa1v);
					else
						llinum = ((labs(ya1v-y2))<<tempchar)/labs(ya2v-ya1v);

					x3 = (((long)((xdim>>1)-xb2[i]))<<19)/(yn2*(xdim>>3));
					y3 = (2097152L/yn2);
					x2 = posx-((x3*sintable[(2048-ang)&2047] - y3*sintable[(2560-ang)&2047])>>15);
					y2 = posy-((x3*sintable[(2560-ang)&2047] + y3*sintable[(2048-ang)&2047])>>15);
					if (labs(xa1v-xa2v) >= labs(ya1v-ya2v))
						rlinum = ((labs(xa1v-x2))<<tempchar)/labs(xa2v-xa1v);
					else
						rlinum = ((labs(ya1v-y2))<<tempchar)/labs(ya2v-ya1v);

					llinum *= ((long)lin[daline].repeat);
					rlinum *= ((long)lin[daline].repeat);
					top = 0L, topinc = (rlinum-llinum)*(yb1[i]>>1);
					bot = (xb2[i]-xb1[i])*(yb2[i]>>1), botinc = (yb1[i]>>1)-(yb2[i]>>1);
					for(j=xb1[i];j<=xb2[i];j++)
					{
						if (bot != 0)
							linum[j] = llinum+(top/bot);
						top += topinc;
						bot += botinc;
						if ((top&0x40000000) != 0)
						{
							top >>= 1;
							bot >>= 1;
							topinc >>= 1;
							botinc >>= 1;
						}
					}
					k = 0;
					for(j=xb1[i];j<xb2[i];j+=2)
					{
						if ((lin[daline].cstat&16) > 0)
							vline2(j,uplace[j],dplace[j],uplace[j+1],dplace[j+1],hc3>>1,(hc3+hi3)>>1,picn[0],(short)linum[j],(short)linum[j+1],lin[daline].shade);
						else
							vline2(j,uplace[j],dplace[j],uplace[j+1],dplace[j+1],hc3,hc3+hi3,picn[0],(short)linum[j],(short)linum[j+1],lin[daline].shade);
						hc3 += hi3+hi3;
					}
					if (((xb2[i]-xb1[i])&1) == 0)
					{
						if ((lin[daline].cstat&16) > 0)
							vline(j,uplace[j],dplace[j],hc3>>1,picn[0],(short)linum[j],lin[daline].shade);
						else
							vline(j,uplace[j],dplace[j],hc3,picn[0],(short)linum[j],lin[daline].shade);
					}
					takernum = 4;
				}
				for(j=xb1[i];j<=xb2[i];j++)
					if (dmost[j] >= umost[j])
					{
						if ((lin[daline].cstat&15) == 6)
						{
							if (((short int)(uplace[j]>>16)) <= dmost[j])
								dmost[j] = ((short int)(uplace[j]>>16));
							if (swapped[i] == 0)
								dzmost[j] = z1v;
							else
								dzmost[j] = z2v;
						}
						else if ((lin[daline].cstat&15) == 9)
						{
							if (((short int)(dplace[j]>>16)) >= umost[j])
								umost[j] = ((short int)(dplace[j]>>16));
							if (swapped[i] == 0)
								uzmost[j] = z2v;
							else
								uzmost[j] = z1v;
						}
						if (((lin[daline].cstat&15) == 3) || (umost[j] > dmost[j]))
						{
							umost[j] = 100;
							dmost[j] = 99;
							numhits--;
							if (numhits < 0)
							{
								j = xb2[i];
								i = lintalplc;
								break;
							}
						}
					}
				if ((ceilingstat > 0) && (ceilingstat < 4))
				{
					if ((lin[daline].cstat&1) > 0)
						for(m=um;m<=up;m++)
							if (uxsave[m+1] >= 0)
							{
								if (swapped[i] == 0)
									hline(uxsave[m+1],j-1,m,dztop,picn[1],lin[daline].shade1);
								else
									hline(uxsave[m+1],j-1,m,dzbot,picn[2],lin[daline].shade2);
								uxsave[m+1] = -1;
							}
					if ((lin[daline].cstat&2) > 0)
						for(m=dp;m<=dm;m++)
							if (dxsave[m+1] >= 0)
							{
								if (swapped[i] == 0)
									hline(dxsave[m+1],j-1,m,dzbot,picn[2],lin[daline].shade2);
								else
									hline(dxsave[m+1],j-1,m,dztop,picn[1],lin[daline].shade1);
								dxsave[m+1] = -1;
							}
				}
			}
		}
	}
	lintalplc = 0;
	takernum = 0;
	return(0);
}

drawsprites()
{
	unsigned char shiftval, shadeoffs;
	unsigned short int thesiz, walnume, picplc;
	unsigned long vinc, nvinc, vplc, p;
	long siz, y1, y2, ny1, ny2, linume, lininc, pictot, xsiz, ysiz;
	short int i, j, k, lside, rside, maskval, gap, temp, sordi;

	takernum = 3;
	for(i=0;i<snum;i++)
		sord[i] = i;
	gap = (snum>>1);
	while (gap > 0)
	{
		for(i=0;i<snum-gap;i++)
		{
			temp = i;
			while (sizs[temp] > sizs[temp+gap])
			{
				j = sord[temp];
				sord[temp] = sord[temp+gap];
				sord[temp+gap] = j;
				temp -= gap;
				if (temp < 0)
					break;
			}
		}
		gap >>= 1;
	}
	for(i=0;i<snum;i++)
	{
		sordi = sord[i];
		if (sizs[sordi] == 0)
			sizs[sordi] = 1;
		vinc = 4194304L / sizs[sordi];
		shadeoffs = lin[sline[sordi]].shade;
		if (((char)(vinc>>16)) < 8)
			shadeoffs -= (char)(vinc>>16);
		else
			shadeoffs -= 8;
		if ((lin[sline[sordi]].cstat&16) > 0)
		{
			sizs[sordi] >>= 1;
			vinc <<= 1;
			if (sizs[sordi] == 0)
				sizs[sordi] = 1;
		}
		walnume = lin[sline[sordi]].picnum;
		if (ceilingstat >= 3)
			walnume = 55;
		if (picanm[walnume] > 0)
			walnume += (numframes%(picanm[walnume]+1));
		xsiz = ((sizs[sordi]<<(picsiz[walnume]&15))>>6);
		ysiz = ((sizs[sordi]<<(picsiz[walnume]>>4))>>6);
		lside = (short)(xs[sordi]-(xsiz>>1));
		rside = (short)(lside+xsiz);
		y1 = ys[sordi]-(ysiz>>1);
		y2 = y1+ysiz;
		shiftval = 32-(picsiz[walnume]>>4);
		nvinc = vinc<<(shiftval-16);
		pictot = (1<<((long)((picsiz[walnume]&15)+(picsiz[walnume]>>4))));
		linume = 0L;
		lininc = (pictot<<16)/(xsiz+1);
		maskval = ((0xffff>>(16-(picsiz[walnume]&15)))<<(picsiz[walnume]>>4));
		if ((sizs[sordi] > 1) && (picsiz[walnume] != 0))
			for(j=lside;j<=rside;j++)
			{
				if ((j >= 0) && (j < xdim) && (y1 <= sdmost[sordi][j]) && (y2 >= sumost[sordi][j]))
				{
					ny1 = y1;
					ny2 = y2;
					picplc = ((short)(linume>>16))&maskval;
					vplc = (((long)picplc)<<16);
					if (ny1 < ((long)sumost[sordi][j]))
					{
						vplc += ((((long)sumost[sordi][j]))-ny1)*vinc;
						ny1 = ((long)sumost[sordi][j]);
					}
					if (ny2 > ((long)sdmost[sordi][j])) ny2 = ((long)sdmost[sordi][j]);
					thesiz = ny2-ny1;
					if ((thesiz > 0) && (thesiz <= ydim))
					{
						vplc <<= (shiftval-16);
						p = ((long)(ny1*320+j))+0x000a0000+centeroffset;
						svlineasm1(nvinc&0xffffff00,(vplc&0xffffff00)|shiftval,(thesiz<<8)+shadeoffs,picplc+waloff[walnume],p);
					}
				}
				linume += lininc;
			}
	}
	return(0);
}
