#include <stdio.h>
#include <conio.h>
#include <dos.h>

#define COMBUFSIZ 16384

volatile long comnum, comvect, comspeed, comtemp;
volatile char *inbuf, *outbuf;
volatile short *inbufplc, *inbufend, *outbufplc, *outbufend, *comport;

static unsigned short orig_pm_sel, orig_rm_seg, orig_rm_off;
static unsigned long orig_pm_off;
static void interrupt far comhandler(void);
static char rmbuffer[256] =
{
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x50,0x53,0x51,0x52,0x2E,0x8B,0x16,0x08,0x00,0x83,
	0xC2,0x02,0xEC,0x24,0x07,0x8A,0xC8,0x80,0xF9,0x02,
	0x0F,0x85,0x26,0x00,0x2E,0x8B,0x1E,0x04,0x00,0x2E,
	0x3B,0x1E,0x06,0x00,0x0F,0x84,0x39,0x00,0x2E,0x8A,
	0x87,0x00,0x41,0x2E,0x8B,0x16,0x08,0x00,0xEE,0x43,
	0x81,0xE3,0xFF,0x3F,0x2E,0x89,0x1E,0x04,0x00,0xEB,
	0x22,0x90,0x80,0xF9,0x04,0x0F,0x85,0x1A,0x00,0x2E,
	0x8B,0x16,0x08,0x00,0xEC,0x2E,0x8B,0x1E,0x02,0x00,
	0x2E,0x88,0x87,0x00,0x01,0x43,0x81,0xE3,0xFF,0x3F,
	0x2E,0x89,0x1E,0x02,0x00,0xF6,0xC1,0x01,0x74,0xA0,
	0xB0,0x20,0xE6,0x20,0x5A,0x59,0x5B,0x58,0xCF,
};

#pragma aux koutp =\
	"out dx, al",\
	parm [edx][eax]\

#pragma aux kinp =\
	"in al, dx",\
	parm [edx]\

main ()
{
	short dat;
	char ch;

	comnum = 2;
	comspeed = 9600;
	comon();

	printf("Move mouse, transmit data; ESC to quit\n");

	ch = 0;
	while (ch != 27)
	{
		if (kbhit() != 0)
		{
			ch = getch();
			comsend((long)ch,1L);
		}

		if ((dat = comgetchar()) != -1)
		{
			printf("%c\n",dat);
		}
	}

	comoff();
}

void *convalloc32 (unsigned long size)
{
	 union REGS r;

	 r.x.eax = 0x0100;           //DPMI allocate DOS memory
	 r.x.ebx = ((size+15)>>4);   //Number of paragraphs requested
	 int386(0x31,&r,&r);

	 if (r.x.cflag != 0)         //Failed
		 return ((unsigned long)0);
	 return ((void *)((r.x.eax&0xffff)<<4));   //Returns full 32-bit offset
}

installbicomhandlers()
{
	char *ptr;
	union REGS r;
	struct SREGS sr;
	void *lowp;
	void far *fh;
	int c;

		//Get old protected mode handler
	r.x.eax = 0x3500+comvect;   /* DOS get vector (INT 0Ch) */
	sr.ds = sr.es = 0;
	int386x(0x21,&r,&r,&sr);
	orig_pm_sel = (unsigned short)sr.es;
	orig_pm_off = r.x.ebx;

		//Get old real mode handler
	r.x.eax = 0x0200;   /* DPMI get real mode vector */
	r.h.bl = comvect;
	int386(0x31,&r,&r);
	orig_rm_seg = (unsigned short)r.x.ecx;
	orig_rm_off = (unsigned short)r.x.edx;

		//Allocate memory in low memory to store real mode handler
	if ((lowp = convalloc32(256+(COMBUFSIZ<<1))) == 0)
	{
		printf("Couldn't allocate conventional memory.\n");
		exit(1);
	}

	inbuf = (char *)(((long)lowp)+256);
	outbuf = (char *)(((long)lowp)+256+COMBUFSIZ);
	inbufplc = (short *)(((long)lowp)+0);
	inbufend = (short *)(((long)lowp)+2);
	outbufplc = (short *)(((long)lowp)+4);
	outbufend = (short *)(((long)lowp)+6);
	comport = (short *)(((long)lowp)+8);

	memcpy(lowp,(void *)rmbuffer,256);

	//printf("%x\n",FP_OFF(lowp));
	//ptr = (char *)(FP_OFF(lowp));
	//for(c=0;c<12;c++)
	//{
	//   printf("%d - %x\n",c,*ptr);
	//   ptr++;
	//}
	//exit(0);

		//Set new protected mode handler
	r.x.eax = 0x2500+comvect;   /* DOS set vector (INT 0Ch) */
	fh = (void far *) comhandler;
	r.x.edx = FP_OFF(fh);
	sr.ds = FP_SEG(fh);      //DS:EDX == &handler
	sr.es = 0;
	int386x(0x21,&r,&r,&sr);

		//Set new real mode handler (must be after setting protected mode)
	r.x.eax = 0x0201;
	r.h.bl = comvect;              //CX:DX == real mode &handler
	r.x.ecx = (((((long)lowp)+10L)>>4)&0xffff);   //D32realseg
	r.x.edx = ((((long)lowp)+10L)&0xf);           //D32realoff
	int386(0x31,&r,&r);
}

uninstallbicomhandlers()
{
	union REGS r;
	struct SREGS sr;

		//restore old protected mode handler
	r.x.eax = 0x2500+comvect;   /* DOS set vector (INT 0Ch) */
	r.x.edx = orig_pm_off;
	sr.ds = orig_pm_sel;    /* DS:EDX == &handler */
	sr.es = 0;
	int386x(0x21,&r,&r,&sr);

		//restore old real mode handler
	r.x.eax = 0x0201;   /* DPMI set real mode vector */
	r.h.bl = comvect;
	r.x.ecx = (unsigned long)orig_rm_seg;     //CX:DX == real mode &handler
	r.x.edx = (unsigned long)orig_rm_off;
	int386(0x31,&r,&r);
}

comon()
{
	long divisor;
	short *ptr;

	if ((comnum < 1) || (comnum > 4)) return(-1);
	comvect = 0xb+(comnum&1);

	installbicomhandlers();
	*inbufplc = 0;
	*inbufend = 0;
	*outbufplc = 0;
	*outbufend = 0;

	ptr = (short *)(0x400L+(long)((comnum-1)<<1));
	*comport = *ptr;
	if (*comport == 0) return(-1);
	if ((comspeed <= 0) || (comspeed > 115200)) return(-1);

	  // Baud-Setting,?,?,Parity O/E,Parity Off/On, Stop-1/2,Bits-5/6/7/8
	  // 0x0b is odd parity,1 stop bit, 8 bits

	_disable();

	outp(*comport+3,0x80);                  //enable latch registers
	divisor = 115200 / comspeed;
	outp(*comport+0,divisor&255);           //# = 115200 / bps
	outp(*comport+1,divisor>>8);
	outp(*comport+3,0x03);                  //0x03 = n,8,1

	outp(*comport+4,0x0b);             //setup for interrupts (modem control)
	outp(*comport+1,0);                //com interrupt disable
	outp(0x21,inp(0x21)&(255-(1<<(comvect&7))));          //Unmask vector
	inp(*comport+6);
	inp(*comport+5);
	inp(*comport+0);
	inp(*comport+2);
	outp(*comport+1,0x03);             //com interrupt enable
	outp(0x20,0x20);

	_enable();

	return(0);
}

comoff()
{
	//while ((*outbufplc != *outbufend) && (keystatus[0x1c] == 0));

	_disable();
	outp(0x21,inp(0x21)|(1<<(comvect&7)));          //Mask vector
	outp(*comport+1,0);
	outp(*comport+4,0);
	uninstallbicomhandlers();
	_enable();
}

comsend(long dat, long numbytes)
{
	long i;

	i = 0;
	while (numbytes > 0)
	{
		outbuf[*outbufend] = (char)((dat>>i)&255);
		*outbufend = ((*outbufend+1)&(COMBUFSIZ-1));

		numbytes--;
		i += 8;
	}
	if ((inp(*comport+5)&0x60) == 0x60)
	{
		if (*outbufplc != *outbufend)
		{
			outp(*comport,outbuf[*outbufplc]);
			*outbufplc = ((*outbufplc+1)&(COMBUFSIZ-1));
		}
	}
	return(0);
}

comgetchar()
{
	short i;

	i = -1;
	if (*inbufplc != *inbufend)
	{
		i = (short)inbuf[*inbufplc];
		*inbufplc = ((*inbufplc+1)&(COMBUFSIZ-1));
	}
	return(i);
}

void __interrupt __far comhandler(void)
{
	do
	{
		comtemp = (kinp(*comport+2)&7);
		if (comtemp == 2)
		{
			if (*outbufplc != *outbufend)
			{
				koutp(*comport,(long)outbuf[*outbufplc]);
				*outbufplc = (((*outbufplc)+1)&(COMBUFSIZ-1));
			}
		}
		else if (comtemp == 4)
		{
			inbuf[*inbufend] = (char)kinp(*comport);
			*inbufend = (((*inbufend)+1)&(COMBUFSIZ-1));
		}
	}
	while ((comtemp&1) == 0);
	koutp(0x20,0x20);
}
