DECLARE SUB hline (x1%, x2%, y%)
DECLARE SUB doublehscan (x1%, x2%)

CONST XDIM = 320, YDIM = 200

DIM SHARED umost%(XDIM - 1), dmost%(XDIM - 1), lastx%(YDIM - 1)
SCREEN 13
LOCATE 1, 1: PRINT "1 - sines, 2 - random"
DO
   z$ = INPUT$(1)
   IF z$ = "1" THEN
      v1 = 2 * RND: v2 = 10 * RND + 2: v3 = 30 * RND + 5
      v4 = 50 * RND + 10: v5 = 30 * RND + 5: v6 = 100 * RND + 20
      v7 = 20 * RND + 5: v8 = 30 * RND + 5: v9 = 2 * RND
      v10 = 15 * RND + 2: v11 = 30 * RND + 10: v12 = 100 * RND + 80
      FOR x% = 0 TO XDIM - 1
         umost%(x%) = INT(COS((x% + v1) / v2)) * v3 + SIN(x% / v4) * v5 + v6
         dmost%(x%) = SIN(x% / v7) * v8 + COS((x% + v9) / v10) * v11 + v12
      NEXT x%
      CALL doublehscan(0, XDIM - 1)
   END IF
   IF z$ = "2" THEN
      FOR x% = 0 TO XDIM - 1
         umost%(x%) = INT(300 * RND) - 50
         dmost%(x%) = INT(300 * RND) - 50
      NEXT x%
      CALL doublehscan(0, XDIM - 1)
   END IF
   LOOP WHILE z$ <> CHR$(27)
END

SUB doublehscan (x1%, x2%)
   LINE (0, 0)-(XDIM - 1, YDIM - 1), 15, BF
   FOR x% = 0 TO XDIM - 1
      IF x% < x1% OR x% > x2% THEN LINE (x%, 0)-(x%, YDIM - 1), 6
      IF umost%(x%) < 0 THEN umost%(x%) = 0
      IF umost%(x%) > YDIM THEN umost%(x%) = YDIM
      IF dmost%(x%) < 0 THEN dmost%(x%) = 0
      IF dmost%(x%) > YDIM THEN dmost%(x%) = YDIM
      IF umost%(x%) > 0 THEN LINE (x%, 0)-(x%, umost%(x%) - 1), 6
      IF dmost%(x%) < YDIM THEN LINE (x%, dmost%(x%))-(x%, YDIM - 1), 6
   NEXT x%
   DO: LOOP WHILE INKEY$ = ""

      'Assumes umost[?] and dmost[?] area already >= 0 and <= YDIM
  
   y1% = umost%(x1%): y2% = y1%
   FOR x% = x1% TO x2%
      twall% = umost%(x%) - 1: bwall% = dmost%(x%)
      IF twall% < bwall% - 1 THEN
         IF twall% >= y2% THEN
            WHILE y1% < y2% - 1: y1% = y1% + 1: CALL hline(lastx%(y1%), x% - 1, y1%): WEND
            y1% = twall%
         ELSE
            WHILE y1% < twall%: y1% = y1% + 1: CALL hline(lastx%(y1%), x% - 1, y1%): WEND
            WHILE y1% > twall%: lastx%(y1%) = x%: y1% = y1% - 1: WEND
         END IF
         WHILE y2% > bwall%: y2% = y2% - 1: CALL hline(lastx%(y2%), x% - 1, y2%): WEND
         WHILE y2% < bwall%: lastx%(y2%) = x%: y2% = y2% + 1: WEND
      ELSE
         WHILE y1% < y2% - 1: y1% = y1% + 1: CALL hline(lastx%(y1%), x% - 1, y1%): WEND
         IF x% = x2% THEN EXIT FOR
         y1% = umost%(x% + 1): y2% = y1%
      END IF
   NEXT x%
   WHILE y1% < y2% - 1: y1% = y1% + 1: CALL hline(lastx%(y1%), x2%, y1%): WEND
END SUB

SUB hline (x1%, x2%, y%)
   FOR z% = x2% TO x1% STEP -1
      IF POINT(z%, y%) <> 15 OR z% < 0 OR z% >= 320 OR y% < 0 OR y% >= 200 THEN
         PSET (z%, y%), 15: SOUND 60, 5
      ELSE
         PSET (z%, y%), 1
      END IF
   NEXT z%
END SUB

