DECLARE FUNCTION scale& (eax&, ebx&, ecx&)
DECLARE FUNCTION mulscale& (eax&, ebx&, ecx&)
DECLARE FUNCTION divscale& (eax&, ebx&, ecx&)
DECLARE SUB drawline256 (x1&, y1&, x2&, y2&, col%)

DIM SHARED wx1&, wy1&, wx2&, wy2&, regs%(7)

regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())

SCREEN 7, , 0, 0

wx1& = 0: wy1& = 0: wx2& = 315 * 4096&: wy2& = 195 * 4096&

x1& = wx1&: y1& = wy1&: x2& = wx2&: y2& = wy2&
spaceflag% = 0
DO
   SCREEN 7, , pag%, 1 - pag%: pag% = 1 - pag%
   WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8
  
   CLS
   CALL drawline256(x1&, y1&, x2&, y2&, 15)
   CIRCLE (x1& \ 4096, y1& \ 4096), 5, 15
   CIRCLE (x2& \ 4096, y2& \ 4096), 5, 15
  
   regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
   IF spaceflag% = 0 THEN
	 x1& = x1& + regs%(2) * 256&: y1& = y1& + regs%(3) * 256&
   ELSE
	 x2& = x2& + regs%(2) * 256&: y2& = y2& + regs%(3) * 256&
   END IF

   z$ = INKEY$
   IF z$ = " " THEN spaceflag% = 1 - spaceflag%
LOOP WHILE z$ <> CHR$(27)

FUNCTION divscale& (eax&, ebx&, ecx&)
   'divscale
   '66 b8 01 00 00 00                    mov     eax,00000001H
   '66 bb 02 00 00 00                    mov     ebx,00000002H
   '66 b9 03 00 00 00                    mov     ecx,00000003H
   '66 99                                cdq
   '66 0f a5 c2                          shld    edx,eax,cl
   '66 d3 e0                             shl     eax,cl
   '66 f7 fb                             idiv    ebx

   '26 a3 00 00 00 00                   mov es:[00000000H], ax
   '66 c1 e8 10                         shr eax, 10H
   '26 a3 00 00 00 00                   mov es:[00000000H], ax

   deax$ = MKL$(eax&): debx$ = MKL$(ebx&): decx$ = MKL$(ecx&)
   segment& = VARSEG(divscale&): offset& = VARPTR(divscale&)

   DIM asmprog%(27)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55                                          'push bp
   POKE p& + 1, &H8B: POKE p& + 2, &HEC                       'mov bp, sp
   POKE p& + 3, &HB8: POKE p& + 4, (segment& AND 255): POKE p& + 5, (segment& \ 256) AND 255
   POKE p& + 6, &H8E: POKE p& + 7, &HC0                       'mov es, ax
   POKE p& + 8, &H66: POKE p& + 9, &HB8: POKE p& + 10, ASC(MID$(deax$, 1, 1)): POKE p& + 11, ASC(MID$(deax$, 2, 1)): POKE p& + 12, ASC(MID$(deax$, 3, 1)): POKE p& + 13, ASC(MID$(deax$, 4, 1))
   POKE p& + 14, &H66: POKE p& + 15, &HBB: POKE p& + 16, ASC(MID$(debx$, 1, 1)): POKE p& + 17, ASC(MID$(debx$, 2, 1)): POKE p& + 18, ASC(MID$(debx$, 3, 1)): POKE p& + 19, ASC(MID$(debx$, 4, 1))
   POKE p& + 20, &H66: POKE p& + 21, &HB9: POKE p& + 22, ASC(MID$(decx$, 1, 1)): POKE p& + 23, ASC(MID$(decx$, 2, 1)): POKE p& + 24, ASC(MID$(decx$, 3, 1)): POKE p& + 25, ASC(MID$(decx$, 4, 1))
   POKE p& + 26, &H66: POKE p& + 27, &H99
   POKE p& + 28, &H66: POKE p& + 29, &HF: POKE p& + 30, &HA5: POKE p& + 31, &HC2
   POKE p& + 32, &H66: POKE p& + 33, &HD3: POKE p& + 34, &HE0
   POKE p& + 35, &H66: POKE p& + 36, &HF7: POKE p& + 37, &HFB
   POKE p& + 38, &H26: POKE p& + 39, &HA3: POKE p& + 40, offset& AND 255: POKE p& + 41, (offset& \ 256) AND 255
   POKE p& + 42, &H66: POKE p& + 43, &HC1: POKE p& + 44, &HE8: POKE p& + 45, &H10
   POKE p& + 46, &H26: POKE p& + 47, &HA3: POKE p& + 48, (offset& + 2) AND 255: POKE p& + 49, ((offset& + 2) \ 256) AND 255
   POKE p& + 50, &H5D                                         'pop bp
   POKE p& + 51, &HCA: POKE p& + 52, &H2: POKE p& + 53, &H0   'ret 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
   ERASE asmprog%
END FUNCTION

SUB drawline256 (tempx1&, tempy1&, tempx2&, tempy2&, col%)
   x1& = tempx1&: y1& = tempy1&: x2& = tempx2&: y2& = tempy2&
  
   dx& = x2& - x1&: dy& = y2& - y1&

   IF dx& >= 0 THEN
	 IF x1& >= wx2& OR x2& < wx1& THEN EXIT SUB
	 IF x1& < wx1& THEN y1& = y1& + scale&(wx1& - x1&, dy&, dx&): x1& = wx1&
	 IF x2& > wx2& THEN y2& = y2& + scale&(wx2& - x2&, dy&, dx&): x2& = wx2&
   ELSE
	 IF x2& >= wx2& OR x1& < wx1& THEN EXIT SUB
	 IF x2& < wx1& THEN y2& = y2& + scale&(wx1& - x2&, dy&, dx&): x2& = wx1&
	 IF x1& > wx2& THEN y1& = y1& + scale&(wx2& - x1&, dy&, dx&): x1& = wx2&
   END IF
  
   IF dy& >= 0 THEN
	 IF y1& >= wy2& OR y2& < wy1& THEN EXIT SUB
	 IF y1& < wy1& THEN x1& = x1& + scale&(wy1& - y1&, dx&, dy&): y1& = wy1&
	 IF y2& > wy2& THEN x2& = x2& + scale&(wy2& - y2&, dx&, dy&): y2& = wy2&
   ELSE
	 IF y2& >= wy2& OR y1& < wy1& THEN EXIT SUB
	 IF y2& < wy1& THEN x2& = x2& + scale&(wy1& - y2&, dx&, dy&): y2& = wy1&
	 IF y1& > wy2& THEN x1& = x1& + scale&(wy2& - y1&, dx&, dy&): y1& = wy2&
   END IF
  
   IF ABS(dx&) >= ABS(dy&) THEN
	 IF dx& = 0 THEN EXIT SUB
	 IF dx& < 0 THEN SWAP x1&, x2&: SWAP y1&, y2&
	
	 inc& = divscale&(dy&, dx&, 12)
	 dax1& = (x1& + 2048) \ 4096: dax2& = (x2& - 2048) \ 4096
	 plc& = y1& + mulscale&((2047 - x1&) AND 4095, inc&, 12)
	 FOR x& = dax1& TO dax2&
	    PSET (x&, plc& \ 4096), 15
	    plc& = plc& + inc&
	 NEXT x&
   ELSE
	 IF dy& < 0 THEN SWAP x1&, x2&: SWAP y1&, y2&

	 inc& = divscale&(dx&, dy&, 12)
	 day1& = (y1& + 2048) \ 4096: day2& = (y2& - 2048) \ 4096
	 plc& = x1& + mulscale&((2047 - y1&) AND 4095, inc&, 12)
	 FOR y& = day1& TO day2&
	    PSET (plc& \ 4096, y&), 15
	    plc& = plc& + inc&
	 NEXT y&
   END IF
END SUB

FUNCTION mulscale& (eax&, ebx&, ecx&)
   'mulscale
   '66 b8 01 00 00 00                    mov     eax,00000001H
   '66 bb 02 00 00 00                    mov     ebx,00000002H
   '66 b9 03 00 00 00                    mov     ecx,00000003H
   '66 f7 eb                             imul    ebx
   '66 0f ad d0                          shrd    eax,edx,cl

   '26 a3 00 00 00 00                   mov es:[00000000H], ax
   '66 c1 e8 10                         shr eax, 10H
   '26 a3 00 00 00 00                   mov es:[00000000H], ax

   deax$ = MKL$(eax&): debx$ = MKL$(ebx&): decx$ = MKL$(ecx&)
   segment& = VARSEG(mulscale&): offset& = VARPTR(mulscale&)

   DIM asmprog%(25)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55                                          'push bp
   POKE p& + 1, &H8B: POKE p& + 2, &HEC                       'mov bp, sp
   POKE p& + 3, &HB8: POKE p& + 4, (segment& AND 255): POKE p& + 5, (segment& \ 256) AND 255
   POKE p& + 6, &H8E: POKE p& + 7, &HC0                       'mov es, ax
   POKE p& + 8, &H66: POKE p& + 9, &HB8: POKE p& + 10, ASC(MID$(deax$, 1, 1)): POKE p& + 11, ASC(MID$(deax$, 2, 1)): POKE p& + 12, ASC(MID$(deax$, 3, 1)): POKE p& + 13, ASC(MID$(deax$, 4, 1))
   POKE p& + 14, &H66: POKE p& + 15, &HBB: POKE p& + 16, ASC(MID$(debx$, 1, 1)): POKE p& + 17, ASC(MID$(debx$, 2, 1)): POKE p& + 18, ASC(MID$(debx$, 3, 1)): POKE p& + 19, ASC(MID$(debx$, 4, 1))
   POKE p& + 20, &H66: POKE p& + 21, &HB9: POKE p& + 22, ASC(MID$(decx$, 1, 1)): POKE p& + 23, ASC(MID$(decx$, 2, 1)): POKE p& + 24, ASC(MID$(decx$, 3, 1)): POKE p& + 25, ASC(MID$(decx$, 4, 1))
   POKE p& + 26, &H66: POKE p& + 27, &HF7: POKE p& + 28, &HEB
   POKE p& + 29, &H66: POKE p& + 30, &HF: POKE p& + 31, &HAD: POKE p& + 32, &HD0
   POKE p& + 33, &H26: POKE p& + 34, &HA3: POKE p& + 35, offset& AND 255: POKE p& + 36, (offset& \ 256) AND 255
   POKE p& + 37, &H66: POKE p& + 38, &HC1: POKE p& + 39, &HE8: POKE p& + 40, &H10
   POKE p& + 41, &H26: POKE p& + 42, &HA3: POKE p& + 43, (offset& + 2) AND 255: POKE p& + 44, ((offset& + 2) \ 256) AND 255
   POKE p& + 45, &H5D                                         'pop bp
   POKE p& + 46, &HCA: POKE p& + 47, &H2: POKE p& + 48, &H0   'ret 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
   ERASE asmprog%
END FUNCTION

FUNCTION scale& (eax&, ebx&, ecx&)
   'scale
   '66 b8 01 00 00 00                    mov     eax,00000001H
   '66 bb 02 00 00 00                    mov     ebx,00000002H
   '66 b9 03 00 00 00                    mov     ecx,00000003H
   '66 f7 eb                             imul    ebx
   '66 f7 f9                             idiv    ecx

   '26 a3 00 00 00 00                   mov es:[00000000H], ax
   '66 c1 e8 10                         shr eax, 10H
   '26 a3 00 00 00 00                   mov es:[00000000H], ax

   deax$ = MKL$(eax&): debx$ = MKL$(ebx&): decx$ = MKL$(ecx&)
   segment& = VARSEG(scale&): offset& = VARPTR(scale&)

   DIM asmprog%(25)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55                                          'push bp
   POKE p& + 1, &H8B: POKE p& + 2, &HEC                       'mov bp, sp
   POKE p& + 3, &HB8: POKE p& + 4, (segment& AND 255): POKE p& + 5, (segment& \ 256) AND 255
   POKE p& + 6, &H8E: POKE p& + 7, &HC0                       'mov es, ax
   POKE p& + 8, &H66: POKE p& + 9, &HB8: POKE p& + 10, ASC(MID$(deax$, 1, 1)): POKE p& + 11, ASC(MID$(deax$, 2, 1)): POKE p& + 12, ASC(MID$(deax$, 3, 1)): POKE p& + 13, ASC(MID$(deax$, 4, 1))
   POKE p& + 14, &H66: POKE p& + 15, &HBB: POKE p& + 16, ASC(MID$(debx$, 1, 1)): POKE p& + 17, ASC(MID$(debx$, 2, 1)): POKE p& + 18, ASC(MID$(debx$, 3, 1)): POKE p& + 19, ASC(MID$(debx$, 4, 1))
   POKE p& + 20, &H66: POKE p& + 21, &HB9: POKE p& + 22, ASC(MID$(decx$, 1, 1)): POKE p& + 23, ASC(MID$(decx$, 2, 1)): POKE p& + 24, ASC(MID$(decx$, 3, 1)): POKE p& + 25, ASC(MID$(decx$, 4, 1))
   POKE p& + 26, &H66: POKE p& + 27, &HF7: POKE p& + 28, &HEB
   POKE p& + 29, &H66: POKE p& + 30, &HF7: POKE p& + 31, &HF9
   POKE p& + 32, &H26: POKE p& + 33, &HA3: POKE p& + 34, offset& AND 255: POKE p& + 35, (offset& \ 256) AND 255
   POKE p& + 36, &H66: POKE p& + 37, &HC1: POKE p& + 38, &HE8: POKE p& + 39, &H10
   POKE p& + 40, &H26: POKE p& + 41, &HA3: POKE p& + 42, (offset& + 2) AND 255: POKE p& + 43, ((offset& + 2) \ 256) AND 255
   POKE p& + 44, &H5D                                         'pop bp
   POKE p& + 45, &HCA: POKE p& + 46, &H2: POKE p& + 47, &H0   'ret 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
   ERASE asmprog%
END FUNCTION

