DECLARE SUB showchar (c%, d%, z%)
DECLARE SUB showfont ()
DECLARE SUB savesmallfnt ()
DECLARE SUB loadsmallfnt ()

CONST NUMCHARS = 256

DIM SHARED smallfnt%(NUMCHARS, 8, 8)
CALL loadsmallfnt
SCREEN 7

c% = 0: d% = 0: z% = 0: trail% = 0
CALL showfont: CALL showchar(c%, d%, z%)
DO
   z$ = INKEY$
  
   IF z$ <> "" THEN
	 IF z$ = "t" OR z$ = "T" THEN trail% = 1 - trail%
  
	 IF z$ = " " OR trail% = 1 THEN
	    smallfnt%(z%, c%, d%) = smallfnt%(z%, c%, d%) XOR 1
	 END IF
   
	 IF z$ = CHR$(0) + CHR$(75) AND c% > 0 THEN c% = c% - 1
	 IF z$ = CHR$(0) + CHR$(77) AND c% < 7 THEN c% = c% + 1
	 IF z$ = CHR$(0) + CHR$(72) AND d% > 0 THEN d% = d% - 1
	 IF z$ = CHR$(0) + CHR$(80) AND d% < 7 THEN d% = d% + 1

	 IF z$ = CHR$(0) + CHR$(73) THEN
		z% = (z% - 1) AND (NUMCHARS - 1)
		trail% = 0
		CALL showfont
	 END IF
	 IF z$ = CHR$(0) + CHR$(81) THEN
	    z% = (z% + 1) AND (NUMCHARS - 1)
	    trail% = 0
	    CALL showfont
	 END IF

	 CALL showchar(c%, d%, z%)
   END IF
LOOP WHILE z$ <> CHR$(27)

CALL savesmallfnt

SUB loadsmallfnt
   OPEN "smallfnt.dat" FOR BINARY AS #1
   z$ = STRING$(NUMCHARS * 8, 0): GET #1, , z$
   p& = 1
   FOR z% = 0 TO (NUMCHARS - 1)
	 FOR y% = 0 TO 7
	    dat% = ASC(MID$(z$, p&, 1))
	    pow2% = 128
	    FOR x% = 0 TO 7
		  IF (pow2% AND dat%) > 0 THEN smallfnt%(z%, x%, y%) = 1
		  pow2% = pow2% \ 2
	    NEXT x%
	    p& = p& + 1
	 NEXT y%
   NEXT z%
   CLOSE #1
END SUB

SUB savesmallfnt
   OPEN "smallfnt.dat" FOR BINARY AS #1
   z$ = ""
   FOR z% = 0 TO (NUMCHARS - 1)
	 FOR y% = 0 TO 7
	    dat% = 0: pow2% = 128
	    FOR x% = 0 TO 7
		  IF smallfnt%(z%, x%, y%) > 0 THEN dat% = dat% + pow2%
		  pow2% = pow2% \ 2
	    NEXT x%
	    z$ = z$ + CHR$(dat%)
	 NEXT y%
   NEXT z%
   PUT #1, , z$
   CLOSE #1
END SUB

SUB showchar (c%, d%, z%)
   LOCATE 8, 1: COLOR 15: PRINT z%; "   ";
   LOCATE 6, 2
   IF z% = 7 OR (z% >= 9 AND z% <= 13) OR (z% >= 28 AND z% <= 31) THEN
	 PRINT " ";
   ELSE
	 PRINT CHR$(z%);
   END IF
  
   FOR zx% = 0 TO 32 STEP 4
	 LINE (zx%, 0)-(zx%, 32), 7
	 LINE (0, zx%)-(32, zx%), 7
   NEXT zx%

   FOR x% = 0 TO 7
	 FOR y% = 0 TO 7
	    IF x% < 2 OR x% > 5 OR y% < 1 OR y% > 6 THEN
		  col% = 1 - smallfnt%(z%, x%, y%) * 7
	    ELSE
		  col% = smallfnt%(z%, x%, y%) * 7
	    END IF
	    LINE (x% * 4 + 1, y% * 4 + 1)-(x% * 4 + 3, y% * 4 + 3), col%, BF
	    PSET (x% + 16, y% + 40), col%
	 NEXT y%
   NEXT x%

   PSET (c% * 4 + 2, d% * 4 + 2), POINT(c% * 4 + 2, d% * 4 + 2) XOR 15
END SUB

SUB showfont
   xoff% = 0: yoff% = 100
   FOR z% = 0 TO NUMCHARS - 1
	 FOR x% = 0 TO 7
	    FOR y% = 0 TO 7
		  PSET (x% + xoff%, y% + yoff%), smallfnt%(z%, x%, y%) * 7
	    NEXT y%
	 NEXT x%
	 xoff% = xoff% + 8: IF xoff% >= 320 THEN xoff% = 0: yoff% = yoff% + 8
   NEXT z%
END SUB

