CONST XDIM = 320, YDIM = 200

SCREEN 7

DIM SHARED px(8), py(8), pz(8)
DIM SHARED rx(8), ry(8), rz(8)
DIM SHARED sx&(8), sy&(8)
DIM SHARED pt%(6, 4), et&(6), pe%(12, 2), fe%(24), got%(8)

FOR z% = 0 TO 7
   READ px(z%), py(z%), pz(z%)
   px(z%) = px(z%) * 64: py(z%) = py(z%) * 64: pz(z%) = pz(z%) * 64
NEXT z%
FOR z% = 0 TO 5: READ pt%(z%, 0), pt%(z%, 1), pt%(z%, 2), pt%(z%, 3): NEXT z%
FOR z% = 0 TO 5: READ v1%, v2%, v3%, v4%: et&(z%) = (2 ^ v1%) XOR (2 ^ v2%) XOR (2 ^ v3%) XOR (2 ^ v4%): NEXT z%
FOR z% = 0 TO 11: READ pe%(z%, 0), pe%(z%, 1): NEXT z%
FOR z% = 0 TO 23: READ fe%(z%): NEXT z%

zdist = 208: a1 = 0: a2 = 0: a3 = 0
DO
   c1 = COS(a1): s1 = SIN(a1)
   c2 = COS(a2): s2 = SIN(a2)
   c3 = COS(a3): s3 = SIN(a3)
   c1s3 = c1 * s3: c1c3 = c1 * c3
   s1s3 = s1 * s3: s1c3 = s1 * c3
   gxx = -s2 * s1s3 + c1c3
   gxy = -s2 * c1s3 - s1c3
   gxz = -c2 * s3
   gyx = s1 * c2
   gyy = c1 * c2
   gyz = -s2
   gzx = s2 * s1c3 + c1s3
   gzy = s2 * c1c3 - s1s3
   gzz = c2 * c3
  
   CLS
   edge& = 0
   FOR z% = 0 TO 7: got%(z%) = 0: NEXT z%
   FOR z% = 0 TO 5
      FOR zz% = 0 TO 3
         zx% = pt%(z%, zz%)
         IF got%(zx%) = 0 THEN
            got%(zx%) = 1
            ox = px(zx%): oy = py(zx%): oz = pz(zx%)
            rx(zx%) = gxx * ox + gxy * oy + gxz * oz
            ry(zx%) = gyx * ox + gyy * oy + gyz * oz
            rz(zx%) = gzx * ox + gzy * oy + gzz * oz
         END IF
      NEXT zz%

      i0% = pt%(z%, 0): i1% = pt%(z%, 1): i2% = pt%(z%, 3)
     
      x1 = rx(i1%) - rx(i0%): x2 = rx(i2%) - rx(i0%)
      y1 = ry(i1%) - ry(i0%): y2 = ry(i2%) - ry(i0%)
      z1 = rz(i1%) - rz(i0%): z2 = rz(i2%) - rz(i0%)
      nx = y1 * z2 - y2 * z1
      ny = x2 * z1 - x1 * z2
      nz = x1 * y2 - x2 * y1
      dist = nx * rx(i0%) + ny * ry(i0%) + nz * (rz(i0%) + zdist)
      IF dist > 0 THEN edge& = edge& XOR et&(z%)
   NEXT z%
   pow2& = 1: pow22& = 4096
   FOR z% = 0 TO 11
      IF (edge& AND (pow2& + pow22&)) <> 0 THEN
        
         i1% = pe%(z%, 0)
         IF got%(i1%) = 1 THEN
            got%(i1%) = 0
            zscale = (XDIM \ 2) / (rz(i1%) + zdist)
            sx&(i1%) = (rx(i1%) * zscale) + (XDIM \ 2)
            sy&(i1%) = (ry(i1%) * zscale) + (YDIM \ 2)
         END IF
        
         i2% = pe%(z%, 1)
         IF got%(i2%) = 1 THEN
            got%(i2%) = 0
            zscale = (XDIM \ 2) / (rz(i2%) + zdist)
            sx&(i2%) = (rx(i2%) * zscale) + (XDIM \ 2)
            sy&(i2%) = (ry(i2%) * zscale) + (YDIM \ 2)
         END IF

         p& = pow2& + pow22&
         IF (edge& AND p&) = p& THEN col% = 4 ELSE col% = 15
        
         LINE (sx&(i1%), sy&(i1%))-(sx&(i2%), sy&(i2%)), col%
        
         cx& = (sx&(i1%) + sx&(i2%)) \ 2: cy& = (sy&(i1%) + sy&(i2%)) \ 2
         vx& = (sy&(i2%) - sy&(i1%)): vy& = (sx&(i1%) - sx&(i2%))
        
         'dist& = SQR(vx& * vx& + vy& * vy&)

         nvx& = ABS(vx&): nvy& = ABS(vy&): IF nvx& < nvy& THEN SWAP nvx&, nvy&
         IF nvx& > nvy& + nvy& THEN
            dist& = nvx& + (nvy& * 3) \ 16
         ELSE
            dist& = (nvx& * 12 + nvy& * 11) \ 16
         END IF

         IF dist& <> 0 THEN
            vx& = vx& * 8 \ dist&: vy& = vy& * 8 \ dist&
            IF (edge& AND pow2&) <> 0 THEN
               LINE (cx&, cy&)-(cx& - vx&, cy& - vy&), fe%(z%) + 9
            END IF
            IF (edge& AND pow22&) <> 0 THEN
               LINE (cx&, cy&)-(cx& + vx&, cy& + vy&), fe%(z% + 12) + 9
            END IF
         END IF

      END IF
      pow2& = pow2& + pow2&: pow22& = pow22& + pow22&
   NEXT z%

   a1 = a1 + .0125: a2 = a2 - .005: a3 = a3 + .0025
  
   SCREEN 7, , pag%, 1 - pag%: pag% = 1 - pag%
   WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8
LOOP WHILE INKEY$ = ""

   'coordinates of points
DATA -1,-1,-1
DATA  1,-1,-1
DATA -1, 1,-1
DATA  1, 1,-1
DATA -1,-1, 1
DATA  1,-1, 1
DATA -1, 1, 1
DATA  1, 1, 1
  
   'points of faces
DATA 0,4,6,2
DATA 5,1,3,7
DATA 0,1,5,4
DATA 6,7,3,2
DATA 1,0,2,3
DATA 4,5,7,6
  
   'edges of faces
DATA 8,6,22,16
DATA 21,5,11,19
DATA 0,9,14,20
DATA 3,23,13,10
DATA 12,4,1,17
DATA 2,7,15,18

   'points of edges
DATA 0,1
DATA 2,3
DATA 4,5
DATA 6,7
DATA 0,2
DATA 1,3
DATA 4,6
DATA 5,7
DATA 0,4
DATA 1,5
DATA 2,6
DATA 3,7

   'faces of edges
DATA 2,4,5,3,4,1,0,5,0,2,3,1,4,3,2,5,0,4,5,1,2,1,0,3

' The 4 types, from hi to lo: faces(6), edges(12), points(8), coordinates(8)
' The 7 useful conversion tables and array sizes:
'coordinates(points)
'faces(edges)  12*2
'edges(faces)   6*4
'edges(points)  8*3
'points(edges) 12*2
'faces(points)  8*3
'points(faces)  6*4Z

