DECLARE SUB ceilscan (xb1%, xb2%)
CONST xdim = 320
CONST ydim = 200

SCREEN 12
RANDOMIZE TIMER

DIM SHARED umost%(xdim), dmost%(xdim), uplc%(xdim), dplc%(xdim)
DIM SHARED lastx%(ydim + 1)

DO
  
   LINE (0, 0)-(639, 479), 0, BF
   LINE (0 + 160, 0 + 140)-(319 + 160, 199 + 140), 8, BF
  
   GOSUB maketestlines
   DO: LOOP WHILE INKEY$ = ""
  
   CALL ceilscan(0, xdim - 1)
   DO: LOOP WHILE INKEY$ = ""

LOOP
END

maketestlines:
   uc1 = ydim * RND: ui1 = 4 * RND - 2
   uc2 = ydim * RND: ui2 = 4 * RND - 2
   uy1 = ydim * RND: uy2 = ydim * RND
   ui3 = (uy2 - uy1) / xdim: uc3 = uy1
   drew% = 0
   FOR z% = 0 TO xdim - 1
     
      umost%(z%) = uc1: uc1 = uc1 + ui1
      dmost%(z%) = uc2: uc2 = uc2 + ui2
      uplc%(z%) = uc3: uc3 = uc3 + ui3
     
      IF uplc%(z%) >= umost%(z%) AND dmost%(z%) >= umost%(z%) THEN
         theplc% = uplc%(z%)
         IF dmost%(z%) < theplc% THEN theplc% = dmost%(z%)
         LINE (z% + 160, umost%(z%) + 140)-(z% + 160, theplc% + 140), 1: drew% = 1
      END IF
     
      IF RND < .05 THEN ui1 = 4 * RND - 2
      IF uc1 > uc3 AND RND < .05 THEN ui1 = 4 * RND - 4
      IF uc1 > uc2 AND RND < .05 THEN ui1 = 4 * RND - 4: ui2 = 4 * RND
      IF uc1 < 0 THEN uc1 = 0: ui1 = 4 * RND
      IF uc1 >= ydim THEN uc1 = ydim - 1: ui1 = 4 * RND - 4
     
   NEXT z%
RETURN

SUB ceilscan (xb1%, xb2%)
   'Also given: umost[] as top, lowest of dmost[] and uplc[] as bottom
   '(for floor: dmost[] as bottom, highest of umost[] and dplc[] as bottom

   FOR z% = 0 TO ydim
      lastx%(z%) = -1
   NEXT z%
   um% = uplc%(xb1%): up% = um% - 1
  
   FOR j% = xb1% TO xb2%
      theplc% = uplc%(j%)
      IF theplc% < -1 THEN theplc% = -1
      IF theplc% > dmost%(j%) THEN theplc% = dmost%(j%)
     
      WHILE umost%(j%) > um%
         IF lastx%(um% + 1) >= 0 THEN
            LINE (lastx%(um% + 1) + 160, um% + 140)-(j% - 1 + 160, um% + 140), 12
            lastx%(um% + 1) = -1
         END IF
         um% = um% + 1
      WEND
     
      WHILE theplc% < up%
         IF lastx%(up% + 1) >= 0 THEN
            LINE (lastx%(up% + 1) + 160, up% + 140)-(j% - 1 + 160, up% + 140), 12
            lastx%(up% + 1) = -1
         END IF
         up% = up% - 1
      WEND
    
      IF um% > up% + 1 THEN um% = up% + 1
      WHILE umost%(j%) < um%
         um% = um% - 1
         lastx%(um% + 1) = j%
      WEND
      um% = umost%(j%)
    
      IF um% > up% + 1 THEN up% = um% - 1
      WHILE theplc% > up%
         up% = up% + 1
         lastx%(up% + 1) = j%
      WEND
      up% = theplc%

   NEXT j%
  
   FOR z% = um% TO up%
      IF lastx%(z% + 1) >= 0 THEN
         LINE (lastx%(z% + 1) + 160, z% + 140)-(xb2% + 160, z% + 140), 12
         lastx%(z% + 1) = -1
      END IF
   NEXT z%

END SUB

