SCREEN 13
picsiz% = 128
maxwalls% = 4096
DIM buf2%(picsiz%, picsiz%), sintable%(2048), tantable&(1024), radarang%(320)
DIM walsiz%(maxwalls%), walanm%(maxwalls%)
FOR z% = 0 TO picsiz% - 1
   FOR zz% = 0 TO picsiz% - 1
      buf2%(z%, zz%) = z% + zz%
   NEXT zz%
NEXT z%
GOSUB loadtables

OPEN "palette.dat" FOR BINARY AS #1
pal$ = STRING$(768, 0)
GET #1, , pal$
OUT &H3C8, 0
FOR z% = 1 TO 768
   OUT &H3C9, ASC(MID$(pal$, z%, 1))
NEXT z%
CLOSE #1

OPEN "pics.dat" FOR BINARY AS #1
SEEK #1, 1
buf$ = STRING$(maxwalls%, 0)
GET #1, , buf$
FOR z% = 0 TO maxwalls% - 1
   walsiz%(z%) = ASC(MID$(buf$, z% + 1, 1))
NEXT z%
buf$ = STRING$(maxwalls%, 0)
GET #1, , buf$
FOR z% = 0 TO maxwalls% - 1
   walanm%(z%) = ASC(MID$(buf$, z% + 1, 1))
NEXT z%
wallnumber& = 94: GOSUB loadnewall2
CLOSE #1

DEF SEG = &HA000
ang% = 0
DO
   LOCATE 20, 19: PRINT ang%; "  ";
   FOR z% = 0 TO 319
      x% = (sintable%((radarang%(z%) + 2048) AND 2047) \ 102) + ang% \ 2
      y% = (sintable%((radarang%(z%) + 2560) AND 2047) \ 102)
      siz& = 20480 \ y%

      they& = -1: theyinc& = (65536 * picsiz%) \ siz&
      p& = (100 - (siz& * 256& \ 320&)) * 320& + z%
      FOR zx% = 0 TO siz& - 1
         they& = they& + theyinc&
         IF p& >= 0 THEN POKE p&, buf2%(x% AND (picsiz% - 1), (they& \ 65536) AND (picsiz% - 1))
         p& = p& + 320
      NEXT zx%
   NEXT z%
   ang% = ang% + 16
LOOP WHILE INKEY$ = ""
END

loadtables:
   OPEN "tables.dat" FOR BINARY AS #1
   z$ = STRING$(4096, 0)
   GET #1, , z$
   FOR z% = 0 TO 2047
      sintable%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   GET #1, , z$
   FOR z% = 0 TO 1023
      tantable&(z%) = CVL(MID$(z$, z% * 4 + 1, 4))
   NEXT z%
   z$ = STRING$(640, 0)
   GET #1, , z$
   FOR z% = 0 TO 319
      radarang%(z%) = CVI(MID$(z$, z% * 2 + 1, 2))
   NEXT z%
   CLOSE #1
RETURN

loadnewall2:
   IF walsiz%(wallnumber&) = 0 THEN RETURN
   FOR z% = 0 TO wallnumber& - 1
      IF walsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((walsiz%(z%) AND 15) + (walsiz%(z%) \ 16))
   NEXT z%
   SEEK #1, totsiz& + maxwalls% * 2 + 1
   xdim& = 2 ^ (walsiz%(wallnumber&) AND 15)
   ydim& = 2 ^ (walsiz%(wallnumber&) \ 16)
   buf$ = STRING$(xdim& * ydim&, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO xdim& - 1
      FOR zz% = 0 TO ydim& - 1
         buf2%(z%, zz%) = PEEK(offs&): offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
RETURN

