DECLARE SUB loadtables ()

SCREEN 12   'Warning: circles don't draw right in screen 9

DIM SHARED sintable&(2048), regs%(7)

regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
CALL loadtables

searchx& = 320: searchy& = 240
x1& = -1: y1& = -1: x2& = -1: y2& = -1: x3& = -1: y3& = -1
obstatus% = -1

PSET (searchx&, searchy&), POINT(searchx&, searchy&) XOR 15
DO
   regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
   PSET (searchx&, searchy&), POINT(searchx&, searchy&) XOR 15
   searchx& = searchx& + regs%(2)
   IF searchx& < 4 THEN searchx& = 4
   IF searchy& < 4 THEN searchy& = 4
   searchy& = searchy& + regs%(3)
   IF searchx& > 635 THEN searchx& = 635
   IF searchy& > 475 THEN searchy& = 475
   PSET (searchx&, searchy&), POINT(searchx&, searchy&) XOR 15
   regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
   obstatus% = bstatus%: bstatus% = regs%(0)
  
   IF bstatus% > obstatus% THEN
      IF x1& < 0 THEN
         x1& = searchx&: y1& = searchy&
      ELSEIF x2& < 0 THEN
         x2& = searchx&: y2& = searchy&
      ELSEIF x3& < 0 THEN
         x3& = searchx&: y3& = searchy&
      ELSE
         CLS
         x1& = -1: y1& = -1: x2& = -1: y2& = -1: x3& = -1: y3& = -1
         PSET (searchx&, searchy&), POINT(searchx&, searchy&) XOR 15
      END IF
   END IF
  
   IF x1& >= 0 THEN PSET (x1&, y1&), 15
   IF x2& >= 0 THEN LINE -(x2&, y2&), 15
   IF x3& >= 0 THEN
      LINE -(x3&, y3&), 15: LINE -(x1&, y1&), 15
     
      bot& = (y1& - y2&) * (x1& - x3&) - (y3& - y1&) * (x2& - x1&)
      topt& = (x3& - x2&) * (x1& - x3&) - (y3& - y1&) * (y3& - y2&)
      cx& = ((x1& + x2&) + ((y1& - y2&) * topt&) \ bot&) \ 2
      cy& = ((y1& + y2&) + ((x2& - x1&) * topt&) \ bot&) \ 2
     
      r& = SQR((cx& - x1&) * (cx& - x1&) + (cy& - y1&) * (cy& - y1&))
      CIRCLE (cx&, cy&), r&, 6
      LINE ((x1& + x2&) \ 2, (y1& + y2&) \ 2)-(cx&, cy&), 4
      LINE ((x1& + x3&) \ 2, (y1& + y3&) \ 2)-(cx&, cy&), 4
      LINE ((x2& + x3&) \ 2, (y2& + y3&) \ 2)-(cx&, cy&), 4
   END IF

LOOP WHILE INKEY$ <> CHR$(27)

'cx = (x1+x2)\2 + t(y1-y2)
'cy = (y1+y2)\2 + t(x2-x1)
'cx = (x1+x3)\2 + u(y1-y3)
'cy = (y1+y3)\2 + u(x3-x1)
'xx = (x1+x3)\2 - (x1+x2)\2
'yy = (y1+y3)\2 - (y1+y2)\2
't(y1-y2) + u(y3-y1) = xx
't(x2-x1) + u(x1-x3) = yy
'bot = (y1-y2)*(x1-x3) - (y3-y1)*(x2-x1)
'topt = xx*(x1-x3) - (y3-y1)*yy

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

