DECLARE SUB initedges ()
DECLARE SUB mergewall (x1%, x2%, sectnum%, locking%)
DECLARE SUB showedges (y%)
CONST XDIM = 320

DIM SHARED edgenext%(XDIM), edgesect%(XDIM)

SCREEN 13
RANDOMIZE TIMER

DO
   CALL initedges
   CALL showedges(0)
  
   FOR z% = 1 TO 72
      x1% = INT(320 * RND)
      x2% = INT(320 * RND)
      IF x1% > x2% THEN SWAP x1%, x2%
     
      CALL mergewall(x1%, x2%, z% + 31, 1) 'INT(1.1 * RND))
     
      showedges (z%)
   NEXT z%
  
   z$ = INPUT$(1)
LOOP WHILE z$ <> CHR$(27)

SUB initedges
   edgenext%(0) = 320
   edgesect%(0) = -1
END SUB

SUB mergewall (x1%, x2%, sectnum%, locking%)
   IF locking% <> 0 THEN locking% = 16384
  
   dax1% = 0
   WHILE ((edgenext%(dax1%) AND 16383) < x1%)
      dax1% = (edgenext%(dax1%) AND 16383)
   WEND
   dax2% = dax1%
   WHILE ((edgenext%(dax2%) AND 16383) < x2%)
      dax2% = (edgenext%(dax2%) AND 16383)
   WEND

   secondsectnum% = edgesect%(dax2%)
   secondlocking% = (edgenext%(dax2%) AND 16384)

   IF dax1% <> dax2% THEN
    
      lastx% = dax1%: x% = (edgenext%(dax1%) AND 16383)
   
      WHILE x% <> dax2%
       
         IF (edgenext%(x%) AND 16384) = 0 THEN
            IF (edgenext%(lastx%) AND 16384) <> 0 THEN
               lastx% = x%
               edgesect%(lastx%) = sectnum%
               edgenext%(lastx%) = edgenext%(lastx%) + locking%
            ELSE
               edgenext%(lastx%) = x%
            END IF
         END IF
        
         x% = (edgenext%(x%) AND 16383)
      WEND
   END IF
  
   IF (edgenext%(dax2%) AND 16384) = 0 THEN
      edgenext%(x2%) = (edgenext%(dax2%) AND 16383) + secondlocking%
      edgesect%(x2%) = secondsectnum%
      edgenext%(dax2%) = x2%
   END IF
  
   IF (edgenext%(dax1%) AND 16384) = 0 THEN
      edgenext%(x1%) = (edgenext%(dax1%) AND 16383) + locking%
      edgesect%(x1%) = sectnum%
      edgenext%(dax1%) = x1%
   END IF

END SUB

SUB showedges (y%)
   cnt% = 0
   x% = 0
   LINE (0, 150)-(319, 199), 0, BF
   WHILE x% < 320
      nextx% = (edgenext%(x%) AND 16383)
      locking% = (edgenext%(x%) AND 16384)
      sectnum% = edgesect%(x%)

      LINE (x%, 150 + cnt%)-(nextx%, 150 + (40 - cnt%)), 15

      LINE (x%, y% * 2)-(nextx% - 1, y% * 2 + 1), sectnum%, BF
      IF locking% <> 0 THEN
         LINE (x%, y% * 2)-(x%, y% * 2 + 1), sectnum% + 72
         LINE (nextx% - 1, y% * 2)-(nextx% - 1, y% * 2 + 1), sectnum% + 72
         IF sectnum% = y% + 31 THEN LINE (x%, y% * 2)-(nextx% - 1, y% * 2), sectnum% + 72
         FOR x% = x% + 1 TO nextx% - 2 STEP 2
            PSET (x%, y% * 2), sectnum% + 72
            PSET (x% + 1, y% * 2 + 1), sectnum% + 72
         NEXT x%
      END IF

      x% = nextx%
      cnt% = 40 - cnt%
   WEND
   DO: LOOP WHILE INKEY$ = ""
END SUB

