DECLARE FUNCTION gettrans% (dat1%, dat2%)
SCREEN 13: DEF SEG = &HA000
DIM SHARED pal%(768), r%(256), g%(256), b%(256)

OPEN "palette.dat" FOR BINARY AS #1
pal$ = STRING$(768, 0): GET #1, , pal$

numpalookups% = 0
snot$ = STRING$(128, 0)
WHILE EOF(1) = 0
   GET #1, , snot$
   IF EOF(1) = 0 THEN numpalookups% = numpalookups% + 1
WEND
IF (numpalookups% AND 1) <> 0 THEN
   'Transluscent palette also in palette.dat
   SEEK #1, 768& + (numpalookups% \ 2) * 256& - (32768 - 128) + 1
ELSE
   SEEK #1, 768& + (numpalookups% \ 2) * 256& + 1
END IF

FOR z% = 0 TO 767
   pal%(z%) = ASC(MID$(pal$, z% + 1, 1))
NEXT z%
OUT &H3C8, 0
FOR z% = 0 TO 255
   OUT &H3C9, pal%(z% * 3 + 0): r%(z%) = pal%(z% * 3 + 0)
   OUT &H3C9, pal%(z% * 3 + 1): g%(z%) = pal%(z% * 3 + 1)
   OUT &H3C9, pal%(z% * 3 + 2): b%(z%) = pal%(z% * 3 + 2)
NEXT z%

FOR z% = 0 TO 255
   PSET (z%, zz%), z%
NEXT z%
FOR z% = 0 TO 254
   z$ = STRING$(255 - z%, 0)
   FOR zz% = z% + 1 TO 255
      col% = gettrans%(z%, zz%)
      MID$(z$, zz% - z%, 1) = CHR$(col%)
      IF zz% + 2 < 200 THEN PSET (z%, zz% + 2), col%
      IF z% + 2 < 200 THEN PSET (zz%, z% + 2), col%
   NEXT zz%
   PUT #1, , z$
NEXT z%

CLOSE #1

FUNCTION gettrans% (dat1%, dat2%)
   r& = (r%(dat1%) + r%(dat2%)) \ 2
   g& = (g%(dat1%) + g%(dat2%)) \ 2
   b& = (b%(dat1%) + b%(dat2%)) \ 2

   col% = 0
   closest& = &H7FFFFFFF
   FOR zx% = 0 TO 255
      dar& = (r%(zx%) - r&) '* 30
      dag& = (g%(zx%) - g&) '* 59
      dab& = (b%(zx%) - b&) '* 11
      dist& = dar& * dar& + dag& * dag& + dab& * dab&
      IF dist& < closest& THEN
         closest& = dist&
         col% = zx%
      END IF
   NEXT zx%

   gettrans% = col%
END FUNCTION

