#include <string.h>
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>

#define NUMOPTIONS 4                       //temp
unsigned char option[NUMOPTIONS];          //temp

static long note[8192], chanage[18], musicstatus, adlibcount, countstop;
static short nownote, numnotes, numchans, firstime = 1, drumstat;
static char inst[256][11], databuf[2048], chanfreq[18], chantrack[18];
static char trinst[16], trquant[16], trchan[16], trprio[16], trvol[16];
static char adlibchanoffs[9] = {0,1,2,8,9,10,16,17,18};
static short adlibfreq[63] =
{
	0,
	2390,2411,2434,2456,2480,2506,2533,2562,2592,2625,2659,2695,
	3414,3435,3458,3480,3504,3530,3557,3586,3616,3649,3683,3719,
	4438,4459,4482,4504,4528,4554,4581,4610,4640,4673,4707,4743,
	5462,5483,5506,5528,5552,5578,5605,5634,5664,5697,5731,5767,
	6486,6507,6530,6552,6576,6602,6629,6658,6688,6721,6755,6791,
	7510
};
static short musici, musicj, musicquanter, musicbufnum, musicchan;
static short musicdrumnum, musicfreq, musictrack, musicvolevel, musicvolval;
static long musictemp, musictemplong;


static void (__interrupt __far *oldtimerhandler)();
static void __interrupt __far timerhandler(void);

#pragma aux interruptend =\
	"mov al, 20h",\
	"out 20h, al",\
	modify [eax]\

#pragma aux outdata =\
	"mov dx, 0x388",\
	"add dl, al",\
	"add dl, al",\
	"mov al, bl",\
	"out dx, al",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"inc dx",\
	"mov al, cl",\
	"out dx, al",\
	"mov ecx, 33",\
	"outdatawait: in al, dx",\
	"loop outdatawait",\
	parm [eax][ebx][ecx]\
	modify [eax ebx ecx edx]\

void __interrupt __far timerhandler()
{
	/*if (keystatus[0x9d] == 0)                   //KEYBOARD STUFF
	{
		if (keystatus[0xcb] > 0)
		{
			angvel -= 32;
			if (angvel < -256) angvel = -256;
		}
		if (keystatus[0xcd] > 0)
		{
			angvel += 32;
			if (angvel > 256) angvel = 256;
		}
	}
	else
	{
		if (keystatus[0xcb] > 0)
		{
			svel += 16;
			if (svel > 256) svel = 256;
		}
		if (keystatus[0xcd] > 0)
		{
			svel -= 16;
			if (svel < -256) svel = -256;
		}
	}
	if (keystatus[0x1e] > 0)
	{
		hvel -= 2;
		if (hvel < -32) hvel = -32;
	}
	if (keystatus[0x2c] > 0)
	{
		hvel += 2;
		if (hvel > 32) hvel = 32;
	}
	if (keystatus[0xc8] > 0)
	{
		vel += 16;
		if (vel > 256) vel = 256;
	}
	if (keystatus[0xd0] > 0)
	{
		vel -= 16;
		if (vel < -256) vel = -256;
	}

	if (angvel < 0)
	{
		angvel += 24;
		if (angvel > 0) angvel = 0;
	}
	if (angvel > 0)
	{
		angvel -= 24;
		if (angvel < 0) angvel = 0;
	}
	if (svel < 0)
	{
		svel += 4;
		if (svel > 0) svel = 0;
	}
	if (svel > 0)
	{
		svel -= 4;
		if (svel < 0) svel = 0;
	}
	if (hvel < 0)
	{
		hvel++;
		if (hvel > 0) hvel = 0;
	}
	if (hvel > 0)
	{
		hvel--;
		if (hvel < 0) hvel = 0;
	}
	if (vel < 0)
	{
		vel += 4;
		if (vel > 0) vel = 0;
	}
	if (vel > 0)
	{
		vel -= 4;
		if (vel < 0) vel = 0;
	}

	clockspeed++;
	totalclock++;
	timetakercount[takernum]++;*/

	if (musicstatus > 0)                               //MUSIC STUFF
	{
		adlibcount+=2;
		if (adlibcount >= countstop)
		{
			musicbufnum = 0;
			while (adlibcount >= countstop)
			{
				musictemplong = note[nownote];
				musictrack = (int)((musictemplong>>8)&15);
				if ((musictemplong&192) == 0)
				{
					musici = 0;
					while (((chanfreq[musici] != (musictemplong&63)) || (chantrack[musici] != ((musictemplong>>8)&15))) && (musici < numchans))
						musici++;
					if (musici < numchans)
					{
						databuf[musicbufnum] = (char)0, musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(0xb0+musici); musicbufnum++;
						databuf[musicbufnum] = (unsigned char)((adlibfreq[musictemplong&63]>>8)&223); musicbufnum++;
						chanfreq[musici] = 0;
						chanage[musici] = 0;
					}
				}
				else
				{
					musicvolevel = trvol[musictrack];
					if ((musictemplong&192) == 128)
					{
						musicvolevel -= 4;
						if (musicvolevel < 0)
							musicvolevel = 0;
					}
					if ((musictemplong&192) == 192)
					{
						musicvolevel += 4;
						if (musicvolevel > 63)
							musicvolevel = 63;
					}
					if (musictrack < 11)
					{
						musictemp = 0;
						musici = numchans;
						for(musicj=0;musicj<numchans;musicj++)
							if ((countstop - chanage[musicj] >= musictemp) && (chantrack[musicj] == musictrack))
							{
								musictemp = countstop - chanage[musicj];
								musici = musicj;
							}
						if (musici < numchans)
						{
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0xb0+musici); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)0; musicbufnum++;
							musicvolval = (inst[trinst[musictrack]][1]&192)+(musicvolevel^63);
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0x40+adlibchanoffs[musici]+3); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)musicvolval; musicbufnum++;
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0xa0+musici); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(adlibfreq[musictemplong&63]&255); musicbufnum++;
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0xb0+musici); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)((adlibfreq[musictemplong&63]>>8)|32); musicbufnum++;
							chanfreq[musici] = musictemplong&63;
							chanage[musici] = countstop;
						}
					}
					else if ((drumstat&32) > 0)
					{
						musicfreq = adlibfreq[musictemplong&63];
						switch(musictrack)
						{
							case 11: musicdrumnum = 16; musicchan = 6; musicfreq -= 2048; break;
							case 12: musicdrumnum = 8; musicchan = 7; musicfreq -= 2048; break;
							case 13: musicdrumnum = 4; musicchan = 8; break;
							case 14: musicdrumnum = 2; musicchan = 8; break;
							case 15: musicdrumnum = 1; musicchan = 7; musicfreq -= 2048; break;
						}
						databuf[musicbufnum] = (char)0, musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(0xa0+musicchan); musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(musicfreq&255); musicbufnum++;
						databuf[musicbufnum] = (char)0, musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(0xb0+musicchan); musicbufnum++;
						databuf[musicbufnum] = (unsigned char)((musicfreq>>8)&223); musicbufnum++;
						databuf[musicbufnum] = (char)0, musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(0xbd); musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(drumstat&(255-musicdrumnum)); musicbufnum++;
						drumstat |= musicdrumnum;
						if ((musictrack == 11) || (musictrack == 12) || (musictrack == 14))
						{
							musicvolval = (inst[trinst[musictrack]][1]&192)+(musicvolevel^63);
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0x40+adlibchanoffs[musicchan]+3); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(musicvolval); musicbufnum++;
						}
						else
						{
							musicvolval = (inst[trinst[musictrack]][6]&192)+(musicvolevel^63);
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0x40+adlibchanoffs[musicchan]); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(musicvolval); musicbufnum++;
						}
						databuf[musicbufnum] = (char)0, musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(0xbd); musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(drumstat); musicbufnum++;
					}
				}
				nownote++;
				if (nownote >= numnotes)
					nownote = 0;
				musictemplong = note[nownote];
				if (nownote == 0)
					adlibcount = (musictemplong>>12)-1;
				musicquanter = (240/trquant[(musictemplong>>8)&15]);
				countstop = (((musictemplong>>12)+(musicquanter>>1)) / musicquanter) * musicquanter;
			}
			for(musici=0;musici<musicbufnum;musici+=3)
				outdata((long)databuf[musici],(long)databuf[musici+1],(long)databuf[musici+2]);
		}
	}

	interruptend();
}

loadmusic(filename)
char filename[80];
{
	char buffer[256], instbuf[11];
	int infile, i, j;

	if (option[2] == 0)
		return(0);

	if (firstime == 1)
	{
		if((infile=open("insts.dat",O_BINARY|O_RDONLY,S_IREAD))==-1)
		{
			printf("I cannot load insts.dat!");
			exit(0);
		}
		for(i=0;i<256;i++)
		{
			read(infile,&buffer[0],33);
			for(j=0;j<11;j++)
				inst[i][j] = buffer[j+20];
		}
		close(infile);
		numchans = 9;
		outdata(0L,0x1L,32L);  //clear test stuff
		outdata(0L,0x4L,0L);   //reset
		outdata(0L,0x8L,0L);   //2-operator synthesis
		firstime = 0;
	}
	if ((strstr(filename,".KSM") == 0) && (strstr(filename,".ksm") == 0))
		strcat(filename,".KSM");
	if((infile=open(filename,O_BINARY|O_RDONLY,S_IREAD))==-1)
	{
		printf("I cannot load %s.",filename);
		exit(0);
	}
	read(infile,&trinst[0],16);
	read(infile,&trquant[0],16);
	read(infile,&trchan[0],16);
	read(infile,&trprio[0],16);
	read(infile,&trvol[0],16);
	read(infile,&numnotes,2);
	read(infile,&note[0],numnotes<<2);
	close(infile);
	if (trchan[11] == 0)
	{
		drumstat = 0;
		numchans = 9;
		outdata(0L,0xbdL,(long)drumstat);
	}
	if (trchan[11] == 1)
	{
		for(i=0;i<11;i++)
			instbuf[i] = inst[trinst[11]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[11])^63);
		setinst((char)0,6,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		for(i=0;i<5;i++)
			instbuf[i] = inst[trinst[12]][i];
		for(i=5;i<11;i++)
			instbuf[i] = inst[trinst[15]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[12])^63);
		instbuf[6] = ((instbuf[6]&192)|(trvol[15])^63);
		setinst((char)0,7,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		for(i=0;i<5;i++)
			instbuf[i] = inst[trinst[14]][i];
		for(i=5;i<11;i++)
			instbuf[i] = inst[trinst[13]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[14])^63);
		instbuf[6] = ((instbuf[6]&192)|(trvol[13])^63);
		setinst((char)0,8,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		drumstat = 32;
		numchans = 6;
		outdata(0L,0xbdL,(long)drumstat);
	}
	return(0);
}

musicon()
{
	char ch;
	unsigned int num;
	int i, j, k, offs;
	unsigned char instbuf[11];
	unsigned long templong;

	if (option[2] == 0)
		return(0);

	for(i=0;i<numchans;i++)
	{
		chantrack[i] = 0;
		chanage[i] = 0;
	}
	j = 0;
	for(i=0;i<16;i++)
		if ((trchan[i] > 0) && (j < numchans))
		{
			k = trchan[i];
			while ((j < numchans) && (k > 0))
			{
				chantrack[j] = i;
				k--;
				j++;
			}
		}
	for(i=0;i<numchans;i++)
	{
		for(j=0;j<11;j++)
			instbuf[j] = inst[trinst[chantrack[i]]][j];
		instbuf[1] = ((instbuf[1]&192)|(63-trvol[chantrack[i]]));
		setinst((char)0,i,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		chanfreq[i] = 0;
	}
	k = 0;
	musicstatus = 0;
	templong = note[0];
	adlibcount = (templong>>12)-1;
	countstop = (templong>>12)-1;
	nownote = 0;
	musicstatus = 1;
	return(0);
}

musicoff()
{
	int i;

	if (option[2] == 0)
		return(0);

	for(i=0;i<numchans;i++)
	{
		outdata(0L,0xa0L+(long)i,0L);
		outdata(0L,0xb0L+(long)i,0L);
	}
	musicstatus = 0;
	return(0);
}

setinst(synth,chan,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10)
int chan;
unsigned char synth,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10;
{
	int offs;

	outdata((long)synth,0xa0L+(long)chan,0L);
	outdata((long)synth,0xb0L+(long)chan,0L);
	outdata((long)synth,0xc0L+(long)chan,(long)v10);
	offs = adlibchanoffs[chan];
	outdata((long)synth,0x20L+(long)offs,(long)v5);
	outdata((long)synth,0x40L+(long)offs,(long)v6);
	outdata((long)synth,0x60L+(long)offs,(long)v7);
	outdata((long)synth,0x80L+(long)offs,(long)v8);
	outdata((long)synth,0xe0L+(long)offs,(long)v9);
	offs+=3;
	outdata((long)synth,0x20L+(long)offs,(long)v0);
	outdata((long)synth,0x40L+(long)offs,(long)v1);
	outdata((long)synth,0x60L+(long)offs,(long)v2);
	outdata((long)synth,0x80L+(long)offs,(long)v3);
	outdata((long)synth,0xe0L+(long)offs,(long)v4);
}

main()
{
	option[2] = 1;

	musicstatus = 0;                            //initengine
	oldtimerhandler = _dos_getvect(0x8);
	_dos_setvect(0x8, timerhandler);
	outp(0x43,54); outp(0x40,9942&255); outp(0x40,9942>>8);

	loadmusic("maxosong.ksm");
	musicon();
	getch();
	musicoff();

	_dos_setvect(0x8, oldtimerhandler);        //uninitengine
	outp(0x43,54); outp(0x40,255); outp(0x40,255);
}
