@echo off
if "%1"=="" goto help
if not exist tables.dat goto builderror
if not exist palette.dat goto builderror
if not exist boards.dat goto builderror
if not exist pics.dat goto builderror
if not exist build.bmp goto builderror
if not exist build.exe goto builderror
if not exist %1.dat goto error
attrib -r -h -s +a %1.dat
attrib -r -h -s +a boards.dat
ren %1.dat ~swap.tmp
if not exist boards.dat goto runormal
ren boards.dat %1.dat
ren ~swap.tmp boards.dat
BUILD.EXE
ren %1.dat ~swap.tmp
ren boards.dat %1.dat
ren ~swap.tmp boards.dat
echo.
goto endit

:error
echo %1.dat does not exist.
echo.
goto endit

:builderror
echo Build system file missing.  The following are possibilities:
echo BUILD.EXE, BOARDS.DAT, PICS.DAT, PALETTE.DAT, TABLES.DAT, BUILD.BMP
echo.
goto endit

:runormal
ren ~swap.tmp %1.dat
BUILD.EXE
echo.
goto endit

:help
echo.
echo       -=[ B.BAT by Andy Cotter ]=-
echo.
echo    Syntax: B [board file]
echo       Where [board file] is a valid build
echo       board file in the current directory.
echo.
echo    Note: If you specify a file that is NOT a
echo       valid build board file, some REALLY
echo       destructive things could happen.
echo.
goto endit

:endit
